<?php

namespace AppBundle\Controller;

use AppBundle\Entity\TCarrera;
use AppBundle\Entity\TContenido;
use AppBundle\Entity\TEvaluacion;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use AppBundle\Models\DocumentAny;

/**
 * Tcontenido controller.
 *
 * @Route("tcontenido")
 */
class TContenidoController extends Controller
{
    /**
     * Lists all tContenido entities.
     *
     * @Route("/{idCurso}/{idTipo}/inicio", name="tcontenido_index", requirements={"idTipo"="\d+"})
     * @Method({"GET", "POST"})
     */
    public function indexAction($idCurso, $idTipo=0)
    {
        $em = $this->getDoctrine()->getManager();

        $usuario = $this->getUser();
        $tCurso = $em->getRepository('AppBundle:TUsuario')->findCursoEspecífico(1, $idCurso);
        $habilitaExamen = false;

        $tContenidosProfe = $em->getRepository('AppBundle:TUsuario')->findContenidoEspecíficoProfe(1, $idCurso, $usuario, $idTipo);

        $dioEvaluacion = $this->getDoctrine()->getRepository(TEvaluacion::class)->findByIdCurso($idCurso);
//        var_dump($dioEvaluacion[0]->getIdEvaluacion()); exit();
//        var_dump($usuario->getUsCarnet()); exit();

        if($dioEvaluacion)
            $dioExamen = $em->getRepository('AppBundle:TUsuario')->findExamen($dioEvaluacion[0]->getIdEvaluacion(), $usuario->getUsCarnet());
        else
            $dioExamen = false;

//        var_dump( strtotime($tCurso[0]['fechaInicio']->format('Y-m-d H:i:s'))); exit();
        if ($tCurso[0]['fechaInicio']){
            $fecha1 = strtotime($tCurso[0]['fechaInicio']->format('Y-m-d H:i:s'));
            $fecha2 = strtotime($tCurso[0]['fechaFin']->format('Y-m-d H:i:s'));
            $fechaComprobar = strtotime($tCurso[0]['Hoy']);


//        var_dump($fecha1 . ' - '  . $fecha2 . ' - ' . $fechaComprobar); exit();

            if ($fechaComprobar >= $fecha1 and $fechaComprobar <= $fecha2){

                //pregunta si el docente logro insertar el total de sus preguntas
                $tPregResp = $em->getRepository('AppBundle:TUsuario')->findPreguntasRespuestas($idCurso);
                if(empty($tPregResp))
                    $habilitaExamen = false;
                else
                {
//                    var_dump(intval($tPregResp[0]['preguntas'])); exit();
                    if($tPregResp[0]['numeroPreguntas']==intval($tPregResp[0]['preguntas']))
                        $habilitaExamen = true;
                    else
                        $habilitaExamen = false;
                }
//            var_dump('Esta en el rango'); exit();
            }
            else{
                $habilitaExamen = false;
//            var_dump('No esta en el rango'); exit();
            }
        }
        $deleteFormAjax = $this->createCustomForm(':USER_ID', 'DELETE', 'tcontenido_delete');

        return $this->render('tcontenido/contenido.html.twig'
            , array(
                'tCurso' => $tCurso,
                'dioExamen' => $dioExamen,
                'habilitaExamen' => $habilitaExamen,
                'tcontenidos' => $tContenidosProfe,
                'idTipo' => $idTipo,

                'delete_form_ajax' => $deleteFormAjax->createView(),
            ));
    }


    /**
     * Creates a new tContenido entity.
     *
     * @Route("/{idCurso}/{idCarrera}/{idTipo}/new", name="tcontenido_new")
     * @Method({"GET", "POST"})
     */
    public function newAction(Request $request, $idCurso, $idCarrera, $idTipo)
    {
        $usuario = $this->getUser();
        date_default_timezone_set('America/La_Paz');
        $fecha = new \DateTime("now");

        $tContenido = new Tcontenido();
        if($idTipo == 1)
            $form = $this->createForm('AppBundle\Form\TContenidoVideoType', $tContenido);
        if($idTipo == 2)
            $form = $this->createForm('AppBundle\Form\TContenidoArticuloType', $tContenido);
        if($idTipo == 3)
            $form = $this->createForm('AppBundle\Form\TContenidoPDFType', $tContenido);

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $em = $this->getDoctrine()->getManager();
            $tContenido->setIdCarrera($em->getRepository('AppBundle:TCarrera')->find($idCarrera));
            $tContenido->setIdTipoMaterial($em->getRepository('AppBundle:TTipomaterial')->find($idTipo));
            $tContenido->setIdUsuario($usuario);
            $tContenido->setFecha($fecha);

            if($idTipo==3){
                $archivo = $tContenido->getArchivo1();
                if(($archivo instanceof UploadedFile) && ($archivo->getError() == '0'))
                {
                    $originalName = $archivo->getClientOriginalName();
                    $name_array = explode('.',$originalName);
                    $file_type = $name_array[sizeof($name_array) - 1];
                    $valid_filetypes = array('pdf','PDF');
                    if(in_array(strtolower($file_type), $valid_filetypes))
                    {
                        $document = new DocumentAny();
                        $document->setFile($archivo);

                        $document->setSubDirectory('recursos');
                        $document->processFile();
                        $nombre=$document->getFilePersistencePath();

                        $tContenido->setArchivo1($nombre);

                        //var_dump($tRecursos);exit();
                        $em = $this->getDoctrine()->getManager();
                        $em->persist($tContenido);
                        $em->flush();

                        $this->addFlash('mensaje', 'Se agregó el archivo PDF exitósamente.');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo no es la correcta');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }
                else
                {
                    $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo o se produjo un error inesperado');
                    return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                }
            }



            if($idTipo==2){
                $archivo = $tContenido->getArchivo1();
                $archivo2 = $tContenido->getArchivo2();
                $archivo3 = $tContenido->getArchivo3();

                if(($archivo instanceof UploadedFile) && ($archivo->getError() == '0'))
                {
                    $originalName = $archivo->getClientOriginalName();
                    $name_array = explode('.',$originalName);
                    $file_type = $name_array[sizeof($name_array) - 1];
                    $valid_filetypes = array('jpg','jpeg','mp3','docx','pdf', 'JPG','JPEG','MP3','xlsx','PDF','doc','xls','MP4','mp4');
                    if(in_array(strtolower($file_type), $valid_filetypes))
                    {
                        $document = new DocumentAny();
                        $document->setFile($archivo);

                        $document->setSubDirectory('recursos');
                        $document->processFile();
                        $nombre=$document->getFilePersistencePath();

                        $tContenido->setArchivo1($nombre);
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo 1 no es la correcta');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }
                else
                {
                    $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo 1 o se produjo un error inesperado');
                    return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                }

                if(($archivo2 instanceof UploadedFile) && ($archivo2->getError() == '0'))
                {
                    $originalName = $archivo2->getClientOriginalName();
                    $name_array = explode('.',$originalName);
                    $file_type = $name_array[sizeof($name_array) - 1];
                    $valid_filetypes = array('jpg','jpeg','mp3','docx','pdf', 'JPG','JPEG','MP3','xlsx','PDF','doc','xls','MP4','mp4');
                    if(in_array(strtolower($file_type), $valid_filetypes))
                    {
                        $document = new DocumentAny();
                        $document->setFile($archivo2);

                        $document->setSubDirectory('recursos');
                        $document->processFile();
                        $nombre=$document->getFilePersistencePath();

                        $tContenido->setArchivo2($nombre);
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo 2 no es la correcta');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }
                else
                {
                    $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo 2 o se produjo un error inesperado');
                    return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                }

                if(($archivo3 instanceof UploadedFile) && ($archivo3->getError() == '0'))
                {
                    $originalName = $archivo3->getClientOriginalName();
                    $name_array = explode('.',$originalName);
                    $file_type = $name_array[sizeof($name_array) - 1];
                    $valid_filetypes = array('jpg','jpeg','mp3','docx','pdf', 'JPG','JPEG','MP3','xlsx','PDF','doc','xls','MP4','mp4');
                    if(in_array(strtolower($file_type), $valid_filetypes))
                    {
                        $document = new DocumentAny();
                        $document->setFile($archivo3);

                        $document->setSubDirectory('recursos');
                        $document->processFile();
                        $nombre=$document->getFilePersistencePath();

                        $tContenido->setArchivo3($nombre);
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo 3 no es la correcta');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }
                else
                {
                    $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo 3 o se produjo un error inesperado');
                    return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                }

                $em = $this->getDoctrine()->getManager();
                $em->persist($tContenido);
                $em->flush();

                $this->addFlash('mensaje', 'Se agregó el material exitósamente.');
                return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));

            }


            if($idTipo==1){
                $em->persist($tContenido);
                $em->flush();

                $this->addFlash('mensaje', 'Se agregó el Video exitósamente.');
                return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
            }


        }

        return $this->render('tcontenido/new.html.twig', array(
            'tContenido' => $tContenido,
            'idCurso' => $idCurso,
            'idTipo' => $idTipo,
            'form' => $form->createView(),
        ));
    }

    /**
     * Finds and displays a tContenido entity.
     *
     * @Route("/{idContenido}", name="tcontenido_show")
     * @Method("GET")
     */
    public function showAction(TContenido $tContenido)
    {
        $deleteForm = $this->createDeleteForm($tContenido);

        return $this->render('tcontenido/show.html.twig', array(
            'tContenido' => $tContenido,
            'delete_form' => $deleteForm->createView(),
        ));
    }

    /**
     * Displays a form to edit an existing tContenido entity.
     *
     * @Route("/{idContenido}/{idCurso}/{idCarrera}/{idTipo}/edit", name="tcontenido_edit")
     * @Method({"GET", "POST"})
     */
    public function editAction(Request $request, TContenido $tContenido, $idCurso, $idCarrera, $idTipo)
    {
        $usuario = $this->getUser();
        date_default_timezone_set('America/La_Paz');
        $fecha = new \DateTime("now");

        $archivoEmpty1 = $tContenido->getArchivo1();
        $archivoEmpty2 = $tContenido->getArchivo2();
        $archivoEmpty3 = $tContenido->getArchivo3();


        if($idTipo == 1)
            $editForm = $this->createForm('AppBundle\Form\TContenidoVideoType', $tContenido);
        if($idTipo == 2)
            $editForm = $this->createForm('AppBundle\Form\TContenidoArticuloType', $tContenido);
        if($idTipo == 3)
            $editForm = $this->createForm('AppBundle\Form\TContenidoPDFType', $tContenido);

        $editForm->handleRequest($request);

        if ($editForm->isSubmitted() && $editForm->isValid()) {
            $em = $this->getDoctrine()->getManager();
            $tContenido->setIdUsuario($usuario);
            $tContenido->setFecha($fecha);

            if($idTipo==1){
                $this->getDoctrine()->getManager()->flush();

                $this->addFlash('mensaje', 'Se modificó el Contenido del Video exitósamente.');
                return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
            }


            if($idTipo==2){
                $archivo = $tContenido->getArchivo1();
                $archivo2 = $tContenido->getArchivo2();
                $archivo3 = $tContenido->getArchivo3();


                if (!$archivo)
                {
                    $tContenido->setArchivo1($archivoEmpty1);
                }else
                {
                    if(($archivo instanceof UploadedFile) && ($archivo->getError() == '0'))
                    {
                        $originalName = $archivo->getClientOriginalName();
                        $name_array = explode('.',$originalName);
                        $file_type = $name_array[sizeof($name_array) - 1];
                        $valid_filetypes = array('jpg','jpeg','mp3','docx','pdf', 'JPG','JPEG','MP3','xlsx','PDF','doc','xls','MP4','mp4');
                        if(in_array(strtolower($file_type), $valid_filetypes))
                        {
                            $document = new DocumentAny();
                            $document->setFile($archivo);

                            $document->setSubDirectory('recursos');
                            $document->processFile();
                            $nombre=$document->getFilePersistencePath();

                            $tContenido->setArchivo1($nombre);
                        }
                        else
                        {
                            $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo 1 no es la correcta');
                            return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                        }
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo 1 o se produjo un error inesperado');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }

                if (!$archivo2)
                {
                    $tContenido->setArchivo2($archivoEmpty2);

                }else
                {
                    if(($archivo2 instanceof UploadedFile) && ($archivo2->getError() == '0'))
                    {
                        $originalName = $archivo2->getClientOriginalName();
                        $name_array = explode('.',$originalName);
                        $file_type = $name_array[sizeof($name_array) - 1];
                        $valid_filetypes = array('jpg','jpeg','mp3','docx','pdf', 'JPG','JPEG','MP3','xlsx','PDF','doc','xls','MP4','mp4');
                        if(in_array(strtolower($file_type), $valid_filetypes))
                        {
                            $document = new DocumentAny();
                            $document->setFile($archivo2);

                            $document->setSubDirectory('recursos');
                            $document->processFile();
                            $nombre=$document->getFilePersistencePath();

                            $tContenido->setArchivo2($nombre);
                        }
                        else
                        {
                            $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo 2 no es la correcta');
                            return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                        }
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo 2 o se produjo un error inesperado');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }

                if (!$archivo3)
                {
                    $tContenido->setArchivo3($archivoEmpty3);
                }else
                {
                    if(($archivo3 instanceof UploadedFile) && ($archivo3->getError() == '0'))
                    {
                        $originalName = $archivo3->getClientOriginalName();
                        $name_array = explode('.',$originalName);
                        $file_type = $name_array[sizeof($name_array) - 1];
                        $valid_filetypes = array('jpg','jpeg','mp3','docx','pdf', 'JPG','JPEG','MP3','xlsx','PDF','doc','xls','MP4','mp4');
                        if(in_array(strtolower($file_type), $valid_filetypes))
                        {
                            $document = new DocumentAny();
                            $document->setFile($archivo3);

                            $document->setSubDirectory('recursos');
                            $document->processFile();
                            $nombre=$document->getFilePersistencePath();

                            $tContenido->setArchivo3($nombre);
                        }
                        else
                        {
                            $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo 3 no es la correcta');
                            return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                        }
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo 3 o se produjo un error inesperado');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }

                $this->getDoctrine()->getManager()->flush();

                $this->addFlash('mensaje', 'Se modificó el material exitósamente.');
                return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));

            }


            if($idTipo==3){
                $archivo = $tContenido->getArchivo1();
                if (!$archivo)
                {
                    $tContenido->setArchivo1($archivoEmpty1);
                    $this->getDoctrine()->getManager()->flush();

                    $this->addFlash('mensaje', 'Se modificó el Contenido de Descargas exitósamente.');
                    return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                }else
                {
                    if(($archivo instanceof UploadedFile) && ($archivo->getError() == '0'))
                    {
                        $originalName = $archivo->getClientOriginalName();
                        $name_array = explode('.',$originalName);
                        $file_type = $name_array[sizeof($name_array) - 1];
                        $valid_filetypes = array('pdf','PDF');
                        if(in_array(strtolower($file_type), $valid_filetypes))
                        {
                            $document = new DocumentAny();
                            $document->setFile($archivo);

                            $document->setSubDirectory('recursos');
                            $document->processFile();
                            $nombre=$document->getFilePersistencePath();

                            $tContenido->setArchivo1($nombre);

                            $this->getDoctrine()->getManager()->flush();

                            $this->addFlash('mensaje', 'Se modificó el Contenido de Descargas exitósamente.');
                            return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                        }
                        else
                        {
                            $this->get('session')->getFlashBag()->add('mensaje', 'La extension del archivo no es la correcta');
                            return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                        }
                    }
                    else
                    {
                        $this->get('session')->getFlashBag()->add('mensaje', 'No ingreso el archivo o se produjo un error inesperado');
                        return $this->redirectToRoute('tcontenido_index', array('idCurso' => $idCurso, 'idTipo' => $idTipo));
                    }
                }
            }
        }

        return $this->render('tcontenido/new.html.twig', array(
            'tContenido' => $tContenido,
            'idCurso' => $idCurso,
            'idTipo' => $idTipo,
            'form' => $editForm->createView(),
        ));

    }

//    /**
//     * Deletes a tContenido entity.
//     *
//     * @Route("/{idContenido}", name="tcontenido_delete")
//     * @Method("DELETE")
//     */
//    public function deleteAction(Request $request, TContenido $tContenido)
//    {
//        $form = $this->createDeleteForm($tContenido);
//        $form->handleRequest($request);
//
//        if ($form->isSubmitted() && $form->isValid()) {
//            $em = $this->getDoctrine()->getManager();
//            $em->remove($tContenido);
//            $em->flush();
//        }
//
//        return $this->redirectToRoute('tcontenido_index');
//    }


//    /**
//     * Creates a form to delete a tContenido entity.
//     *
//     * @param TContenido $tContenido The tContenido entity
//     *
//     * @return \Symfony\Component\Form\Form The form
//     */
//    private function createDeleteForm(TContenido $tContenido)
//    {
//        return $this->createFormBuilder()
//            ->setAction($this->generateUrl('tcontenido_delete', array('idContenido' => $tContenido->getIdcontenido())))
//            ->setMethod('DELETE')
//            ->getForm()
//        ;
//    }



















    private function createCustomForm($id, $method, $route)
    {
        return $this->createFormBuilder()
            ->setAction($this->generateUrl($route, array('id'=>$id)))
            ->setMethod($method)
            ->getForm();
    }

    private function deleteRegistro($em, $tContenido)
    {

        $em->remove($tContenido);
        $em->flush();

        $message = 'El contenido ha sido eliminado exitósamente';

        $removed = 1;
        $alert = 'mensaje';


        return array('removed'=>$removed, 'message'=>$message, 'alert'=>$alert);
    }

    /**
     * @Route("/borrar/{id}", name="tcontenido_delete")
     */
    public function deleteAction(Request $request, TContenido $TContenido)
    {
        //$form = $this->createDeleteForm($tCarrera);
        $form = $this->createCustomForm($TContenido->getIdContenido(), 'DELETE', 'tcontenido_delete');
        $form->handleRequest($request);
        $em = $this->getDoctrine()->getManager();

        if ($form->isSubmitted() && $form->isValid()) {

            if($request->isXMLHttpRequest())
            {
                $res = $this->deleteRegistro($em, $TContenido);

                return new Response(
                    json_encode(array('removed'=>$res['removed'], 'message'=>$res['message'], )),
                    200,
                    array('Content-Type'=>'application/json')
                );
            }

            $res = $this->deleteRegistro($em, $TContenido);

            $this->addFlash($res['alert'], $res['message']);

            return $this->redirectToRoute('tcontenido_index');
        }
    }

}
