<?php

namespace AppBundle\Controller;

use AppBundle\Entity\TCategoria;
use AppBundle\Entity\TEstudiante;
use AppBundle\Entity\TUsuario;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;

use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\HttpFoundation\Request;

use Symfony\Component\HttpFoundation\File\UploadedFile;
use AppBundle\Models\Document;

/**
 * Testudiante controller.
 *
 * @Route("testudiante")
 */
class TEstudianteController extends Controller
{
    /**
     * Lists all tEstudiante entities.
     *
     * @Route("/", name="testudiante_index")
     * @Method("GET")
     */
    public function indexAction()
    {
        $em = $this->getDoctrine()->getManager();

        $tEstudiantes = $em->getRepository('AppBundle:TEstudiante')->findAll();

	    $deleteFormAjax = $this->createCustomForm(':USER_ID', 'DELETE', 'testudiante_delete');
	    
        return $this->render('testudiante/index.html.twig', array(
            'tEstudiantes' => $tEstudiantes,
            'delete_form_ajax' => $deleteFormAjax->createView(),
        ));
    }


//	/**
//	 * Lists all tPeriodo entities.
//	 *
//	 * @Route("/socieconomico/", name="tsocioeconomico_index")
//	 * @Method("GET")
//	 */
//	public function socioeconomicoAction()
//	{
//		$em = $this->getDoctrine()->getManager();
//
//		$tIngresos = $em->getRepository('AppBundle:TUsuario')->findIngresos();
//		$tDependencias = $em->getRepository('AppBundle:TUsuario')->findDependencias();
//		$tViviendas = $em->getRepository('AppBundle:TUsuario')->findViviendas();
//		$tServira = $em->getRepository('AppBundle:TUsuario')->findServira();
//
//		return $this->render('default/socioeconomico.html.twig', array(
//			'tIngresos' => $tIngresos,
//			'tDependencias' => $tDependencias,
//			'tViviendas' => $tViviendas,
//			'tServira' => $tServira,
//		));
//	}


	/**
	 * Lists all tPeriodo entities.
	 *
	 * @Route("/procedencia/", name="tprocedencia_index")
	 * @Method("GET")
	 */
	public function procedenciaAction()
	{
		$em = $this->getDoctrine()->getManager();

		$tMigrantes = $em->getRepository('AppBundle:TUsuario')->findMigrantes();
		$tDistritos = $em->getRepository('AppBundle:TUsuario')->findDistritos();

		return $this->render('default/procedencia.html.twig', array(
			'tMigrantes' => $tMigrantes,
			'tDistritos' => $tDistritos,
		));
	}

	/**
	 * Lists all tPeriodo entities.
	 *
	 * @Route("/familia/", name="tfamilia_index")
	 * @Method("GET")
	 */
	public function familiaAction()
	{
		$em = $this->getDoctrine()->getManager();

		$tCiviles = $em->getRepository('AppBundle:TUsuario')->findCivil();
		$tCantHijos = $em->getRepository('AppBundle:TUsuario')->findCantHijos();
		$tInformo = $em->getRepository('AppBundle:TUsuario')->findInformo();

		return $this->render('default/familia.html.twig', array(
			'tCiviles' => $tCiviles,
			'tCantHijos' => $tCantHijos,
			'tInformo' => $tInformo,
		));
	}

	/**
	 * Lists all tPeriodo entities.
	 *
	 * @Route("/academico/", name="tacademico_index")
	 * @Method("GET")
	 */
	public function academicoAction()
	{
		$em = $this->getDoctrine()->getManager();
		$tInscritos = $em->getRepository('AppBundle:TUsuario')->findInscritos();
		$tTurnos = $em->getRepository('AppBundle:TUsuario')->findTurnos();
		$tEtareos = $em->getRepository('AppBundle:TUsuario')->findEtareos();
		$tEstados = $em->getRepository('AppBundle:TUsuario')->findEstados();
		$tCursos = $em->getRepository('AppBundle:TUsuario')->findCursosHoras();
        $tEstadosCurso = $em->getRepository('AppBundle:TUsuario')->findEstadosCurso();

		return $this->render('default/academico.html.twig', array(
			'tInscritos' => $tInscritos,
			'tTurnos' => $tTurnos,
			'tEtareos' => $tEtareos,
			'tEstados' => $tEstados,
			'tCursos' => $tCursos,
			'tEstadosCurso' => $tEstadosCurso,
		));
	}


	/**
	 * Lists all tPeriodo entities.
	 *
	 * @Route("/violencia/", name="tviolencia_index")
	 * @Method("GET")
	 */
	public function violenciaAction()
	{
		$em = $this->getDoctrine()->getManager();
		$tViolencias = $em->getRepository('AppBundle:TUsuario')->findViolencias();
		$tVictimas = $em->getRepository('AppBundle:TUsuario')->findVictimas();
		$tAtenciones = $em->getRepository('AppBundle:TUsuario')->findAtenciones();

		return $this->render('default/violencia.html.twig', array(
			'tViolencias' => $tViolencias,
			'tVictimas' => $tVictimas,
			'tAtenciones' => $tAtenciones,
		));
	}


    /**
     * Creates a new tEstudiante entity.
     *
     * @Route("/{Carnet}/new", name="testudiante_new")
     * @Method({"GET", "POST"})
     */
    public function newAction(Request $request, $Carnet)
    {
    	if ($Carnet == 1) $Carnet='';
    	$tEstudiante = new Testudiante();
        $form = $this->createForm('AppBundle\Form\TEstudianteType', $tEstudiante, array('Carnet'=>$Carnet));
        $form->handleRequest($request);


        if ($form->isSubmitted() && $form->isValid()) {

	        $em = $this->getDoctrine()->getManager();
            $tEstudiante->setIdGrado($em->getRepository('AppBundle:TGrado')->find(1));
            $tEstudiante->setIdCivil($em->getRepository('AppBundle:TCivil')->find(1));

	        $image = $tEstudiante->getFoto();

	        if(!$image) {
		        $tEstudiante->setFoto('estudiante_generica.jpg' );
	        }
	        else {
		        if ( ( $image instanceof UploadedFile ) && ( $image->getError() == '0' ) ) {
			        $originalName    = $image->getClientOriginalName();
			        $name_array      = explode( '.', $originalName );
			        $file_type       = $name_array[ sizeof( $name_array ) - 1 ];
			        $valid_filetypes = array( 'jpg', 'jpeg', 'png', 'bmp' );
			        if ( in_array( strtolower( $file_type ), $valid_filetypes ) ) {
				        $document = new Document();
				        $document->setFile( $image );

				        $document->setSubDirectory( 'usuarios' );
				        $document->processFile();
				        $nombre = $document->getFilePersistencePath();

				        $tEstudiante->setFoto($nombre );
			        } else {
				        $this->get( 'session' )->getFlashBag()->add( 'mensaje',
					        'La extension de la foto JPG/BMP no es la correcta' );

				        return $this->redirect( $this->generateUrl( 'testudiante_index' ) );
			        }
		        } else {
			        $this->get( 'session' )->getFlashBag()->add( 'mensaje',
				        'No ingresó la imagen o se produjo un error inesperado' );

			        return $this->redirect( $this->generateUrl( 'testudiante_index' ) );
		        }
	        }

	        $em = $this->getDoctrine()->getManager();
            $em->persist($tEstudiante);
            $em->flush();

//            Desde Aquí creamos al Usuario con Rol Estudiante JCSA
            $tUsuario = new Tusuario();

            $password = $tEstudiante->getCarnet();
            $encoder = $this->container->get('security.password_encoder');
            $encoded = $encoder->encodePassword($tUsuario, $password);

            $tUsuario->setPassword($encoded);
            $tUsuario->setIdRol($em->getRepository('AppBundle:TRol')->find(5));
            $tUsuario->setUsername($tEstudiante->getCarnet());
            $tUsuario->setUscelular($tEstudiante->getTelefono());
            $tUsuario->setUscorreo($tEstudiante->getCorreo());
            $tUsuario->setUsfoto($tEstudiante->getFoto());
            $tUsuario->setUsnombres($tEstudiante->getNombre().' '.$tEstudiante->getPaterno().' '.$tEstudiante->getMaterno());
            $tUsuario->setUsdomicilio($tEstudiante->getDireccion());
            $tUsuario->setUsestado(1);
            $tUsuario->setUscarnet($tEstudiante->getCarnet());
            $tUsuario->setRoles(["ROLE_ESTUDIANTE"]);

            $em->persist($tUsuario);
            $em->flush();
//            Hasta Aquí

	        $this->addFlash( 'mensaje', 'Se agregó un estudiante exitósamente.' );

	        if($Carnet=='')
//	        	Estudiante nuevo desde Participantes
                return $this->redirectToRoute('testudiante_index');
	        else
//	        	Estudiante nuevo desde Inscripciones
		        return $this->redirectToRoute( 'tinscripcion_new', array('carnet'=>$Carnet ));
        }

        return $this->render('testudiante/new.html.twig', array(
            'tEstudiante' => $tEstudiante,
            'form' => $form->createView(),
        ));
    }

    /**
     * Finds and displays a tEstudiante entity.
     *
     * @Route("/{idEstudiante}", name="testudiante_show")
     * @Method("GET")
     */
    public function showAction(TEstudiante $tEstudiante)
    {
        return $this->render('testudiante/show.html.twig', array(
            'tEstudiante' => $tEstudiante,
        ));
    }

    /**
     * Displays a form to edit an existing tEstudiante entity.
     *
     * @Route("/{idEstudiante}/edit", name="testudiante_edit")
     * @Method({"GET", "POST"})
     */
    public function editAction(Request $request, TEstudiante $tEstudiante)
    {
	    $imageEmpty = $tEstudiante->getFoto();
        $editForm = $this->createForm('AppBundle\Form\TEstudianteType', $tEstudiante);
        $editForm->handleRequest($request);

        if ($editForm->isSubmitted() && $editForm->isValid()) {
        	$image = $tEstudiante->getFoto();

	        if (!$image)
	        {
		        $tEstudiante->setFoto($imageEmpty);
	        }else
	        {
		        if(($image instanceof UploadedFile) && ($image->getError() == '0'))
		        {
			        $originalName = $image->getClientOriginalName();
			        $name_array = explode('.',$originalName);
			        $file_type = $name_array[sizeof($name_array) - 1];
			        $valid_filetypes = array('jpg','jpeg','bmp');
			        if(in_array(strtolower($file_type), $valid_filetypes))
			        {
				        $document = new Document();
				        $document->setFile($image);
				        // la siguiente fila es opcional si quisiera guardar en una carpeta adicional... solo es para ordenar
				        $document->setSubDirectory('usuarios');
				        $document->processFile();

				        $nombre=$document->getFilePersistencePath();
				        $tEstudiante->setFoto($nombre);
			        }else
			        {
				        $this->get('session')->getFlashBag()->add('mensaje',
					        'La extension de la imagen no es la correcta');
				        return $this->redirect($this->generateUrl('testudiante_index'));
			        }
		        }else
		        {

			        $this->get('session')->getFlashBag()->add('mensaje',
				        'No ingreso la imagen o se produjo un error inesperado');
			        return $this->redirect($this->generateUrl('testudiante_index'));
		        }
	        }

            $this->getDoctrine()->getManager()->flush();

	        $this->addFlash( 'mensaje', 'Se modificó el participante exitósamente.' );
	        return $this->redirectToRoute('testudiante_index');
        }

        return $this->render('testudiante/edit.html.twig', array(
            'tEstudiante' => $tEstudiante,
            'form' => $editForm->createView(),
        ));
    }





	private function createCustomForm($id, $method, $route)
	{
		return $this->createFormBuilder()
		            ->setAction($this->generateUrl($route, array('id'=>$id)))
		            ->setMethod($method)
		            ->getForm();
	}

	private function deleteRegistro($em, $tEstudiante)
	{


		$em->remove($tEstudiante);
		$em->flush();

		/*COPIAR BORRAR EN USUARIO TAMBIÉN JCSA*/
        $em->getRepository('AppBundle:TUsuario')->findBorraUsuario($tEstudiante->getCarnet());

		$message = 'El estudiante ha sido eliminado exitósamente';

		$removed = 1;
		$alert = 'mensaje';

		return array('removed'=>$removed, 'message'=>$message, 'alert'=>$alert);
	}

	/**
	 * @Route("/borrar/{id}", name="testudiante_delete")
	 */
	public function deleteAction(Request $request, TEstudiante $tEstudiante)
	{
		//$form = $this->createDeleteForm($tCurso);
		$form = $this->createCustomForm($tEstudiante->getIdEstudiante(), 'DELETE', 'testudiante_delete');
		$form->handleRequest($request);
		$em = $this->getDoctrine()->getManager();

		if ($form->isSubmitted() && $form->isValid()) {

			if($request->isXMLHttpRequest())
			{
				$res = $this->deleteRegistro($em, $tEstudiante);

				return new Response(
					json_encode(array('removed'=>$res['removed'], 'message'=>$res['message'], )),
					200,
					array('Content-Type'=>'application/json')
				);
			}

			$res = $this->deleteRegistro($em, $tEstudiante);

			$this->addFlash($res['alert'], $res['message']);

			return $this->redirectToRoute('testudiante_index');
		}
	}


}
