<?php

namespace AppBundle\Controller;

use AppBundle\Entity\TCurso;
use AppBundle\Entity\TEstado;
use AppBundle\Entity\TEstudiante;
use AppBundle\Entity\TInscripcion;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;

use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\HttpFoundation\Request;

use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

use Symfony\Component\HttpFoundation\JsonResponse;


/**
 * Tinscripcion controller.
 *
 * @Route("tinscripcion")
 */
class TInscripcionController extends Controller
{
	/**
	 *
	 * @Route("/asistencia/{idCurso}", name="tinscripcion_asistencia")
	 * @Method({"GET", "POST"})
	 */
	public function cursoasistenciaAction(Request $request, $idCurso)
	{
		$em = $this->getDoctrine()->getManager();

		$tCursos = $em->getRepository('AppBundle:TUsuario')->findTodosCursos(1);
		$tParticipantes = $em->getRepository('AppBundle:TUsuario')->findInscripcionesPorCurso($idCurso);

		$choices = array();
		foreach($tCursos as $curso)
		{
			$key = $curso['curso'];
			$choices[$key] = $curso['idCurso'];
		}

		$form2 = $this->createFormBuilder()
		              ->add('miCurso',ChoiceType::class, array(
			              'label'=>'Cursos Habilitados',
			              'choices' => $choices,
			              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'style'  =>'width:300px'),
			              'placeholder' => '----Escoge un Curso',
			              'required'=> true))

		              ->getForm();

		$form2->handleRequest($request);

		if ($form2->isSubmitted() && $form2->isValid() && $form2['miCurso']->getData()<> '') {
			$miCurso = $form2['miCurso']->getData();
		}

		return $this->render( 'tinscripcion/asistenciaCursos.html.twig', array(
			'formAux'         => $form2->createView(),
			'tParticipantes'  => $tParticipantes,
			'idCurso' => $idCurso,
		) );
	}

	/**
	 * Lists all tPeriodo entities.
	 *
	 * @Route("/general/", name="tinscripcion_general")
	 * @Method("GET")
	 */
	public function generalAction()
	{
		$em = $this->getDoctrine()->getManager();
		$tGeneral = $em->getRepository('AppBundle:TUsuario')->findGeneral();

		return $this->render('tinscripcion/reporteGeneral.html.twig', array(
			'tGeneral' => $tGeneral,
		));
	}


	/**
	 *
	 * @Route("/listacursos/{idCurso}", name="tinscripcion_cursos_habiles")
	 * @Method({"GET", "POST"})
	 */
	public function cursohabilAction(Request $request, $idCurso)
	{
		$em = $this->getDoctrine()->getManager();

		$tCursos = $em->getRepository('AppBundle:TUsuario')->findTodosCursos(0);
		$tParticipantes = $em->getRepository('AppBundle:TUsuario')->findInscripcionesPorCurso($idCurso);

		$choices = array();
		foreach($tCursos as $curso)
		{
			$key = $curso['curso'];
			$choices[$key] = $curso['idCurso'];
		}

		$form2 = $this->createFormBuilder()
		              ->add('miCurso',ChoiceType::class, array(
			              'label'=>'Cursos Habilitados',
			              'choices' => $choices,
			              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'style'  =>'width:300px'),
			              'placeholder' => '----Escoge un Curso',
			              'required'=> true))

		              ->getForm();

		$form2->handleRequest($request);

		if ($form2->isSubmitted() && $form2->isValid() && $form2['miCurso']->getData()<> '') {
			$miCurso = $form2['miCurso']->getData();
		}



		return $this->render( 'tinscripcion/listadoCursos.html.twig', array(
			'formAux'         => $form2->createView(),
			'tParticipantes'  => $tParticipantes,
			'idCurso' => $idCurso,
		) );
	}


	/**
	 *
	 * @Route("/curso/{idCurso}", name="tinscripcion_cursos")
	 * @Method({"GET", "POST"})
	 */
	public function cursoAction(Request $request, $idCurso)
	{
		$em = $this->getDoctrine()->getManager();
		$usuario = $this->getUser();

//		var_dump($usuario->getIdUsuario()); exit();

		$tCursos = $em->getRepository('AppBundle:TUsuario')->findCursosProfe(1, $usuario);
		$tParticipantes = $em->getRepository('AppBundle:TUsuario')->findInscripcionesCurso($idCurso, $usuario);
		$tEstados = $em->getRepository('AppBundle:TEstado')->findAll();

		$choices = array();
		foreach($tCursos as $curso)
		{
			$key = $curso['curso'];
			$choices[$key] = $curso['idCurso'];
		}

		$form2 = $this->createFormBuilder()
		              ->add('miCurso',ChoiceType::class, array(
			              'label'=>'Cursos Habilitados',
			              'choices' => $choices,
			              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'style'  =>'width:300px'),
			              'placeholder' => '----Escoge un Curso',
			              'required'=> true))

		              ->getForm();

		$form2->handleRequest($request);

		if ($form2->isSubmitted() && $form2->isValid() && $form2['miCurso']->getData()<> '') {

			$miCurso = $form2['miCurso']->getData();

//			$em = $this->getDoctrine()->getManager();

//				return $this->redirectToRoute( 'thijos_new', array('carnet'=>$carnet ));

		}



		return $this->render( 'tinscripcion/buscaCursos.html.twig', array(
			'formAux'         => $form2->createView(),
			'tParticipantes'  => $tParticipantes,
			'tEstados' => $tEstados,
			'idCurso' => $idCurso,
		) );
	}


	/**
	 * @Route("/estado/{id}/{idEstado}/{idCurso}/{TipoNota}",  name="tinscripcion_estado", methods={"POST", "GET"})
	 */
	public function estadoAction(Request $request, $id, $idEstado, $idCurso, $TipoNota)
	{


		if($request->isXmlHttpRequest()) {
			$usuario = $this->getUser()->getIdusuario();
			$fecha   = ( new \DateTime( "now" ) )->format( 'Y-m-d H:i:s' );

			if($TipoNota <> 9) {
				$em = $this->getDoctrine()->getManager();
				$id = $em->getRepository( 'AppBundle:TUsuario' )->findInscripcion( $id, $idCurso );
				$id = $id[0]['idInscripcion'];
			}

			$Estado = $this->getDoctrine()->getManager();
			$Estado->getRepository( 'AppBundle:TUsuario' )->actualizaEstado( $id, $idEstado, $usuario, $TipoNota);

//			No usamos esto porque cargaria la pagina de nuevo
//			return $this->redirectToRoute( 'tinscripcion_cursos', array( 'idCurso' => $idCurso ) );
			return new JsonResponse('Éxito');
		}
	}



    /**
     * Lists all tInscripcion entities.
     *
     * @Route("/", name="tinscripcion_index")
     * @Method("GET")
     */
    public function indexAction()
    {
	    $em = $this->getDoctrine()->getManager();
	    $tInscripcions = $em->getRepository('AppBundle:TUsuario')->findInscripciones();

	    $deleteFormAjax = $this->createCustomForm(':USER_ID', 'DELETE', 'tinscripcion_delete');
	    
        return $this->render('tinscripcion/index.html.twig', array(
            'tInscripcions' => $tInscripcions,
            'delete_form_ajax' => $deleteFormAjax->createView(),
        ));
    }

    /**
     * Creates a new tInscripcion entity.
     *
     * @Route("/buscar", name="tinscripcion_buscar")
     * @Method({"GET", "POST"})
     */
    public function buscarAction(Request $request)
    {
	    $form2 = $this->createFormBuilder()
		    ->add('carnet',TextType::class,
			    array('label'=>'No. de Carnet',
			          'required'=>true,
			          'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>8, 'onkeypress'=>'return controlnum(event)')))
	                  ->getForm();
	    $form2->handleRequest($request);

	    if ($form2->isSubmitted() && $form2->isValid() && $form2['carnet']->getData()<> '') {

		    $carnet = $form2['carnet']->getData();

		    $em = $this->getDoctrine()->getManager();
		    if ( $em->getRepository( TEstudiante::class )->findBy( [ 'carnet' => $carnet ] ) ) {

			    return $this->redirectToRoute( 'tinscripcion_new', array('carnet'=>$carnet ));
		    }
		    else
		    {
			    return $this->redirectToRoute( 'testudiante_new', array('Carnet'=>$carnet ));
		    }
	    }



	    return $this->render( 'tinscripcion/busca.html.twig', array(
		    'formAux'         => $form2->createView(),
	    ) );
    }



	/**
	 *
	 * @Route("/participantes", name="tinscripcion_participantes")
	 * @Method({"GET", "POST"})
	 */
	public function madresAction(Request $request)
	{
		if($request->isXmlHttpRequest())
		{
			$idCurso = $request->request->get('idCurso');

			$em = $this->getDoctrine()->getManager();
			$usuario = $this->getUser();

			$tParticipantes = $em->getRepository('AppBundle:TUsuario')->findInscripcionesCurso($idCurso, $usuario);


//			$tCursos = $em->getRepository('AppBundle:TUsuario')->findMadres($idCurso);

			return new JsonResponse($tParticipantes);
		}
	}


	/**
	 * Creates a new tInscripcion entity.
	 *
	 * @Route("/{carnet}/new", name="tinscripcion_new")
	 * @Method({"GET", "POST"})
	 */
	public function newAction(Request $request, $carnet)
	{
//			$carnet = $form2['carnet']->getData();

			$em = $this->getDoctrine()->getManager();
			if ( $em->getRepository( TEstudiante::class )->findBy( [ 'carnet' => $carnet ] ) ) {
				$tParticipante = $em->getRepository( TEstudiante::class )->findBy( [ 'carnet' => $carnet ] );

//				var_dump($tParticipante[0]->getIdEstudiante()); exit();

				$tInscripParticipante = $em->getRepository('AppBundle:TUsuario')->findInscripcionEstudiante($tParticipante[0]->getIdEstudiante());

				$tInscripcion = new TInscripcion();

				$tCursos = $em->getRepository('AppBundle:TUsuario')->findCursos(1);

				$choices = array();
				foreach($tCursos as $curso)
				{
					$key = $curso['curso'];
					$choices[$key] = $curso['idCurso'];
				}

				$form = $this->createFormBuilder()
					->add('miCurso',ChoiceType::class, array(
						'label'=>'Cursos Habilitados',
						'choices' => $choices,
						'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px'),
						'placeholder' => '----Escoge un Curso',
						'required'=> true))

				              ->getForm();

				$form->handleRequest( $request );

				if ( $form->isSubmitted() && $form->isValid() ) {
					$miMensaje1='';


					if ( $form['miCurso']->getData() <> '' ) {
//                      Revisa si no esta inscrito en el curso indicado (doble inscripcion)
                        $tValidaDobleInscripcion = $em->getRepository('AppBundle:TUsuario')->findDobleInscripcion($form['miCurso']->getData(), $carnet);

                        if(!$tValidaDobleInscripcion){
                            $tInscripcion->setIdCurso($em->getRepository( TCurso::class )->findBy( [ 'idCurso' => $form['miCurso']->getData() ] )[0] );

                            $tInscripcion->setIdEstudiante($em->getRepository( TEstudiante::class )->findBy( [ 'carnet' => $carnet ] )[0]);
                            $tInscripcion->setIdEstado($em->getRepository( TEstado::class )->findBy( [ 'idEstado' => 5 ] )[0]);

                            $em = $this->getDoctrine()->getManager();
                            $em->persist( $tInscripcion );
                            $em->flush();

                            $this->addFlash( 'mensaje', 'Se agregó la inscripción exitósamente.' );
                            return $this->redirectToRoute( 'tinscripcion_index' );
                        }
                        else
                        {
                            $this->addFlash( 'mensaje', 'NO se realizó la Inscripción. Solo puede Inscribirse 1 vez al mismo curso' );
                            return $this->redirectToRoute( 'tinscripcion_index' );
                        }
					}
					else {
						if ( $form['miCurso']->getData() == '' ) {
							$miMensaje1 = 'Debe Escoger un Curso';
						}

						return $this->render( 'tinscripcion/new.html.twig', array(
							'tInscripcion'  => $tInscripcion,
							'tHistorial'    => $tInscripParticipante,
							'tParticipante' => $tParticipante[0],
							'form'          => $form->createView(),
							'mimensaje1'    => $miMensaje1,

						) );
					}
				}

				return $this->render( 'tinscripcion/new.html.twig', array(
					'tInscripcion' => $tInscripcion,
					'tHistorial' => $tInscripParticipante,
					'tParticipante'=> $tParticipante[0],
					'form'         => $form->createView(),
				) );
			}
			else
			{
				var_dump('No Existe ese carnet');
				exit();
			}

		return $this->render( 'tinscripcion/new.html.twig', array(
			'tInscripcion' => $tInscripcion,
			'tHistorial' => $tInscripParticipante,
			'tParticipante'=> $tParticipante[0],
			'form'         => $form->createView(),
		) );
	}


    /**
     * Finds and displays a tInscripcion entity.
     *
     * @Route("/{idInscripcion}", name="tinscripcion_show")
     * @Method("GET")
     */
    public function showAction(TInscripcion $tInscripcion)
    {


        return $this->render('tinscripcion/show.html.twig', array(
            'tInscripcion' => $tInscripcion,
        ));
    }

    /**
     * Displays a form to edit an existing tInscripcion entity.
     *
     * @Route("/{idInscripcion}/edit", name="tinscripcion_edit")
     * @Method({"GET", "POST"})
     */
    public function editAction(Request $request, TInscripcion $tInscripcion)
    {
	    $em = $this->getDoctrine()->getManager();
	    $tCursos = $em->getRepository('AppBundle:TUsuario')->findCursos(0);



        $editForm = $this->createForm('AppBundle\Form\TInscripcionType', $tInscripcion, array('cursos' => $tCursos, 'idCurso' => $tInscripcion->getIdCurso()));
        $editForm->handleRequest($request);

        if ($editForm->isSubmitted() && $editForm->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('tinscripcion_edit', array('idInscripcion' => $tInscripcion->getIdinscripcion()));
        }

        return $this->render('tinscripcion/edit.html.twig', array(
            'tInscripcion' => $tInscripcion,
            'edit_form' => $editForm->createView(),
        ));
    }






    /**
     * Creates a form to delete a tInscripcion entity.
     *
     * @param TInscripcion $tInscripcion The tInscripcion entity
     *
     * @return \Symfony\Component\Form\Form The form
     */
    private function createDeleteForm(TInscripcion $tInscripcion)
    {
        return $this->createFormBuilder()
            ->setAction($this->generateUrl('tinscripcion_delete', array('idInscripcion' => $tInscripcion->getIdinscripcion())))
            ->setMethod('DELETE')
            ->getForm()
        ;
    }


	private function createCustomForm($id, $method, $route)
	{
		return $this->createFormBuilder()
		            ->setAction($this->generateUrl($route, array('id'=>$id)))
		            ->setMethod($method)
		            ->getForm();
	}

	private function deleteRegistro($em, $tCurso)
	{
		$em->remove($tCurso);
		$em->flush();

		$message = 'La inscripción ha sido eliminado exitósamente';

		$removed = 1;
		$alert = 'mensaje';

		return array('removed'=>$removed, 'message'=>$message, 'alert'=>$alert);
	}

	/**
	 * @Route("/borrar/{id}", name="tinscripcion_delete")
	 */
	public function deleteAction(Request $request, TInscripcion $tInscripcion)
	{
		//$form = $this->createDeleteForm($tCurso);
		$form = $this->createCustomForm($tInscripcion->getIdInscripcion(), 'DELETE', 'tinscripcion_delete');
		$form->handleRequest($request);
		$em = $this->getDoctrine()->getManager();

		if ($form->isSubmitted() && $form->isValid()) {

			if($request->isXMLHttpRequest())
			{
				$res = $this->deleteRegistro($em, $tInscripcion);

				return new Response(
					json_encode(array('removed'=>$res['removed'], 'message'=>$res['message'], )),
					200,
					array('Content-Type'=>'application/json')
				);
			}

			$res = $this->deleteRegistro($em, $tInscripcion);

			$this->addFlash($res['alert'], $res['message']);

			return $this->redirectToRoute('tcurso_index');
		}
	}
}
