<?php

namespace AppBundle\Controller;

use AppBundle\Entity\TRol;
use AppBundle\Entity\TUsuario;
use function PHPSTORM_META\elementType;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;

use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;
use AppBundle\Form\TUsuarioType;

use Symfony\Component\HttpFoundation\File\UploadedFile;
use AppBundle\Models\Document;

/**
 * Tusuario controller.
 *
 * @Route("tusuario")
 */
class TUsuarioController extends Controller
{
    /**
     * Lists all tUsuario entities.
     *
     * @Route("/", name="tusuario_index")
     * @Method("GET")
     */
    public function indexAction()
    {
	    $usuario = $this->getUser();
		//var_dump($usuario->getRoles()); exit();



	    $em = $this->getDoctrine()->getManager();
//	    var_dump($this->isGranted('ROLE_ADMINISTRADOR'));exit();
	    if($this->isGranted('ROLE_ADMINISTRADOR'))
		    $tUsuarios = $em->getRepository('AppBundle:Tusuario')->findAll();
	    else
		    $tUsuarios = $em->getRepository('AppBundle:Tusuario')->findBy(array('idUsuario' => $usuario->getIdusuario() ));

	    $deleteFormAjax = $this->createCustomForm(':USER_ID', 'DELETE', 'tusuario_delete');

	    return $this->render('tusuario/index.html.twig', array(
            'tUsuarios' => $tUsuarios,
            'delete_form_ajax' => $deleteFormAjax->createView()
        ));
    }

    /**
     * Creates a new tUsuario entity.
     *
     * @Route("/new", name="tusuario_new")
     * @Method({"GET", "POST"})
     */
    public function newAction(Request $request)
    {
        $tUsuario = new Tusuario();

	    if($this->isGranted('ROLE_ADMINISTRADOR'))
		    $idRol = 1;
	    if($this->isGranted('ROLE_TECNICO'))
		    $idRol = 2;
	    if($this->isGranted('ROLE_PROFESOR'))
		    $idRol = 3;
	    if($this->isGranted('ROLE_LECTURA'))
		    $idRol = 4;
        if($this->isGranted('ROLE_ESTUDIANTE'))
            $idRol = 5;

	    $form = $this->createForm(TusuarioType::class, $tUsuario, array('usuario'=> $idRol));

//        $form = $this->createForm('AppBundle\Form\TUsuarioType', $tUsuario);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
	        $image = $tUsuario->getUsfoto();

	        $password = $form->get('plainPassword')->getData();

	        $encoder = $this->container->get('security.password_encoder');
	        $encoded = $encoder->encodePassword($tUsuario, $password);
	        $tUsuario->setPassword($encoded);


	        $em = $this->getDoctrine()->getManager();
	        $tRoles = $em->getRepository(TRol::class)->findBy(array('idRol' => $form->get('idRol')->getData()));

	        foreach($tRoles as $cod)
	        {
//					var_dump($cod->getRldescripcion()); exit();
		        $tUsuario->setRoles(array($cod->getRldescripcion()));
	        }

	        if(!$image) {
		        $tUsuario->setUsfoto('usuariogenerico.jpg' );
		        $em = $this->getDoctrine()->getManager();
		        $em->persist($tUsuario);
		        $em->flush();

//		        $this->get('session')->getFlashBag()->add('mensaje', 'Se creó el usuario exitósamente');
		        $this->addFlash('mensaje', 'Se creó el usuario exitósamente');
		        return $this->redirectToRoute('tusuario_index');
	        }
	        if(($image instanceof UploadedFile) && ($image->getError() == '0'))
	        {
		        $originalName = $image->getClientOriginalName();
		        $name_array = explode('.',$originalName);
		        $file_type = $name_array[sizeof($name_array) - 1];
		        $valid_filetypes = array('jpg','jpeg','png','bmp');
		        if(in_array(strtolower($file_type), $valid_filetypes))
		        {
			        $document = new Document();
			        $document->setFile($image);

			        $document->setSubDirectory('usuarios');
			        $document->processFile();
			        $nombre=$document->getFilePersistencePath();

			        $tUsuario->setUsfoto($nombre);

			        $em = $this->getDoctrine()->getManager();
			        $em->persist($tUsuario);
			        $em->flush();

			        $this->addFlash('mensaje', 'Se creó el usuario exitósamente');
			        return $this->redirectToRoute('tusuario_index');
		        }
		        else
		        {
			        $this->get('session')->getFlashBag()->add('mensaje',
				        'La extension del archivo no es la correcta');
			        return $this->redirect($this->generateUrl('tusuario_index'));
		        }
	        }
	        else
	        {
		        $this->get('session')->getFlashBag()->add('mensaje',
			        'No ingreso el archivo o se produjo un error inesperado');
		        return $this->redirect($this->generateUrl('tusuario_index'));
	        }
        }

        return $this->render('tusuario/new.html.twig', array(
            'tUsuario' => $tUsuario,
            'form' => $form->createView(),
        ));
    }

    /**
     * Finds and displays a tUsuario entity.
     *
     * @Route("/{idUsuario}", name="tusuario_show")
     * @Method("GET")
     */
    public function showAction(TUsuario $tUsuario)
    {
        return $this->render('tusuario/show.html.twig', array(
            'tUsuario' => $tUsuario,
        ));
    }

    /**
     * Displays a form to edit an existing tUsuario entity.
     *
     * @Route("/{idUsuario}/edit", name="tusuario_edit")
     * @Method({"GET", "POST"})
     */
    public function editAction(Request $request, TUsuario $tUsuario)
    {
	    $imageEmpty = $tUsuario->getUsfoto();


	    $usuario = $this->getUser();
	    if($this->isGranted('ROLE_ADMINISTRADOR'))
	    	$idRol = 1;
	    if($this->isGranted('ROLE_TECNICO'))
		    $idRol = 2;
	    if($this->isGranted('ROLE_PROFESOR'))
		    $idRol = 3;
	    if($this->isGranted('ROLE_LECTURA'))
		    $idRol = 4;
        if($this->isGranted('ROLE_ESTUDIANTE'))
            $idRol = 5;


	    $editForm = $this->createForm(TusuarioType::class, $tUsuario, array('usuario'=> $idRol));

	    $editForm->handleRequest($request);

	    if ($editForm->isSubmitted() && $editForm->isValid()) {
			$image = $tUsuario->getUsfoto();

		    //del audio
		    $em = $this->getDoctrine()->getManager();
		    $tRoles = $em->getRepository(TRol::class)->findBy(array('idRol' => $tUsuario->getIdRol()));

		    foreach($tRoles as $cod)
		    {
//					var_dump($cod->getRldescripcion()); exit();
			    $tUsuario->setRoles(array($cod->getRldescripcion()));
		    }




		    $password = $editForm->get('plainPassword')->getData();
		    if(!empty($password)) {
			    $encoder = $this->container->get( 'security.password_encoder' );
			    $encoded = $encoder->encodePassword( $tUsuario, $password );
			    $tUsuario->setPassword( $encoded );
		    }
		    else {
			    $id = $tUsuario->getIdUsuario();
			    $recoverPass = $this->recoverPass($id);
			    $tUsuario->setPassword($recoverPass[0]['password']);
		    }

		    if (!$image)
		    {
			    $tUsuario->setUsfoto($imageEmpty);
			    $this->getDoctrine()->getManager()->flush();

//			    $this->get('session')->getFlashBag()->add('mensaje', 'Se actualizó los datos del usuario exitósamente');
			    $this->addFlash('mensaje', 'Se actualizó los datos del usuario exitósamente');

                if($this->isGranted('ROLE_ADMINISTRADOR'))
                    return $this->redirectToRoute('tusuario_index');
                else
                    return $this->redirectToRoute('homepage');

		    }else
		    {
			    if(($image instanceof UploadedFile) && ($image->getError() == '0'))
			    {
				    $originalName = $image->getClientOriginalName();
				    $name_array = explode('.',$originalName);
				    $file_type = $name_array[sizeof($name_array) - 1];
				    $valid_filetypes = array('jpg','jpeg','bmp');
				    if(in_array(strtolower($file_type), $valid_filetypes))
				    {
					    $document = new Document();
					    $document->setFile($image);
					    // la siguiente fila es opcional si quisiera guardar en una carpeta adicional... solo es para ordenar
					    $document->setSubDirectory('usuarios');
					    $document->processFile();

					    $nombre=$document->getFilePersistencePath();
					    $tUsuario->setUsfoto($nombre);

					    $this->getDoctrine()->getManager()->flush();

					    $this->addFlash('mensaje', 'Se actualizó los datos del usuario exitósamente');

                        if($this->isGranted('ROLE_ADMINISTRADOR'))
                            return $this->redirect($this->generateUrl('tusuario_index'));
                        else
                            return $this->redirect($this->generateUrl('homepage'));

				    }else
				    {
					    $this->get('session')->getFlashBag()->add('mensaje',
						    'La extension del archivo no es la correcta');

                        if($this->isGranted('ROLE_ADMINISTRADOR'))
					        return $this->redirect($this->generateUrl('tusuario_index'));
                        else
                            return $this->redirect($this->generateUrl('homepage'));
				    }
			    }else
			    {
				    $this->get('session')->getFlashBag()->add('mensaje',
					    'No ingreso el archivo o se produjo un error inesperado');

                    if($this->isGranted('ROLE_ADMINISTRADOR'))
                        return $this->redirect($this->generateUrl('tusuario_index'));
                    else
                        return $this->redirect($this->generateUrl('homepage'));
			    }
		    }
	    }

        return $this->render('tusuario/edit.html.twig', array(
            'tUsuario' => $tUsuario,
            'form' => $editForm->createView(),
        ));
    }






    private function createCustomForm($id, $method, $route)
    {
        return $this->createFormBuilder()
            ->setAction($this->generateUrl($route, array('id'=>$id)))
            ->setMethod($method)
            ->getForm();
    }


    private function deleteUser($role, $em, $tUsuario)
    {
        if($role <> 'ROLE_SUPER')
        {
            $em->remove($tUsuario);
            $em->flush();

            $message = 'El usuario ha sido eliminado exitosamente';
            //$this->get('session')->getFlashBag()->add('message',
            //                    'Se eliminó el registro exitosamente');
            $removed = 1;
            $alert = 'mensaje';
        }
        else
        {
            $message = 'El SUPER Usuario No puede ser  eliminado';
            $removed = 0;
            $alert = 'error';
        }

        return array('removed'=>$removed, 'message'=>$message, 'alert'=>$alert);
    }


	/**
	 * @Route("/delete/{id}", name="tusuario_delete")
	 */
	public function deleteAction(Request $request, TUsuario $tUsuario)
	{
		$form = $this->createCustomForm($tUsuario->getIdUsuario(), 'DELETE', 'tusuario_delete');
		$form->handleRequest($request);
		$em = $this->getDoctrine()->getManager();

		if ($form->isSubmitted() && $form->isValid()) {

			if($request->isXMLHttpRequest())
			{
				$res = $this->deleteUser($tUsuario->getRoles(), $em, $tUsuario);

				return new Response(
					json_encode(array('removed'=>$res['removed'], 'message'=>$res['message'], )),
					200,
					array('Content-Type'=>'application/json')
				);
			}

			$res = $this->deleteUser($tUsuario->getRoles(), $em, $tUsuario);

			$this->addFlash($res['alert'], $res['message']);

			return $this->redirectToRoute('tusuario_index');
		}
	}





}
