<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
/**
 * TContenido
 *
 * @ORM\Table(name="t_contenido", indexes={@ORM\Index(name="id_usuario", columns={"id_usuario"}), @ORM\Index(name="id_tipomaterial", columns={"id_tipomaterial"}), @ORM\Index(name="id_carrera", columns={"id_carrera"})})
 * @ORM\Entity
 */
class TContenido
{
    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $titulo;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $descripcion;

    /**
     * @var string
     */
    private $fuente;

    /**
     * @var string
     */
    private $archivo1;

    /**
     * @var string
     */
    private $archivo2;

    /**
     * @var string
     */
    private $archivo3;

    /**
     * @var \DateTime
     */
    private $fecha;

    /**
     * @var boolean
     */
    private $activo;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_contenido", type="smallint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idContenido;

    /**
     * @var \AppBundle\Entity\TCarrera
     *
     * @ORM\ManyToOne(targetEntity="TCarrera")
     * @ORM\JoinColumns({
     * @ORM\JoinColumn(name="id_carrera", referencedColumnName="id_carrera")
     * })
     */
    private $idCarrera;

    /**
     * @var \AppBundle\Entity\TTipomaterial
     *
     * @ORM\ManyToOne(targetEntity="TTipomaterial")
     * @ORM\JoinColumns({
     * @ORM\JoinColumn(name="id_tipomaterial", referencedColumnName="id_tipomaterial")
     * })
     */
    private $idTipoMaterial;

    /**
     * @var \AppBundle\Entity\TUsuario
     *
     * @ORM\ManyToOne(targetEntity="TUsuario")
     * @ORM\JoinColumns({
     * @ORM\JoinColumn(name="id_usuario", referencedColumnName="id_usuario")
     * })
     */
    private $idUsuario;


    /**
     * Set titulo
     *
     * @param string $titulo
     *
     * @return TContenido
     */
    public function setTitulo($titulo)
    {
        $this->titulo = $titulo;

        return $this;
    }

    /**
     * Get titulo
     *
     * @return string
     */
    public function getTitulo()
    {
        return $this->titulo;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     *
     * @return TContenido
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set fuente
     *
     * @param string $fuente
     *
     * @return TContenido
     */
    public function setFuente($fuente)
    {
        $this->fuente = $fuente;

        return $this;
    }

    /**
     * Get fuente
     *
     * @return string
     */
    public function getFuente()
    {
        return $this->fuente;
    }

    /**
     * Set archivo1
     *
     * @param string $archivo1
     *
     * @return TContenido
     */
    public function setArchivo1($archivo1)
    {
        $this->archivo1 = $archivo1;

        return $this;
    }

    /**
     * Get archivo1
     *
     * @return string
     */
    public function getArchivo1()
    {
        return $this->archivo1;
    }

    /**
     * Set archivo2
     *
     * @param string $archivo2
     *
     * @return TContenido
     */
    public function setArchivo2($archivo2)
    {
        $this->archivo2 = $archivo2;

        return $this;
    }

    /**
     * Get archivo2
     *
     * @return string
     */
    public function getArchivo2()
    {
        return $this->archivo2;
    }

    /**
     * Set archivo3
     *
     * @param string $archivo3
     *
     * @return TContenido
     */
    public function setArchivo3($archivo3)
    {
        $this->archivo3 = $archivo3;

        return $this;
    }

    /**
     * Get archivo3
     *
     * @return string
     */
    public function getArchivo3()
    {
        return $this->archivo3;
    }

    /**
     * Set fecha
     *
     * @param \DateTime $fecha
     *
     * @return TContenido
     */
    public function setFecha($fecha)
    {
        $this->fecha = $fecha;

        return $this;
    }

    /**
     * Get fecha
     *
     * @return \DateTime
     */
    public function getFecha()
    {
        return $this->fecha;
    }

    /**
     * Set activo
     *
     * @param boolean $activo
     *
     * @return TContenido
     */
    public function setActivo($activo)
    {
        $this->activo = $activo;

        return $this;
    }

    /**
     * Get activo
     *
     * @return boolean
     */
    public function getActivo()
    {
        return $this->activo;
    }

    /**
     * Get idContenido
     *
     * @return integer
     */
    public function getIdContenido()
    {
        return $this->idContenido;
    }

    /**
     * Set idCarrera
     *
     * @param \AppBundle\Entity\TCarrera $idCarrera
     *
     * @return TContenido
     */
    public function setIdCarrera(\AppBundle\Entity\TCarrera $idCarrera = null)
    {
        $this->idCarrera = $idCarrera;

        return $this;
    }

    /**
     * Get idCarrera
     *
     * @return \AppBundle\Entity\TCarrera
     */
    public function getIdCarrera()
    {
        return $this->idCarrera;
    }

    /**
     * Set idTipoMaterial
     *
     * @param \AppBundle\Entity\TTipomaterial $idTipoMaterial
     *
     * @return TContenido
     */
    public function setIdTipoMaterial(\AppBundle\Entity\TTipomaterial $idTipoMaterial = null)
    {
        $this->idTipoMaterial = $idTipoMaterial;

        return $this;
    }

    /**
     * Get idTipoMaterial
     *
     * @return \AppBundle\Entity\TTipomaterial
     */
    public function getIdTipoMaterial()
    {
        return $this->idTipoMaterial;
    }

    /**
     * Set idUsuario
     *
     * @param \AppBundle\Entity\TUsuario $idUsuario
     *
     * @return TContenido
     */
    public function setIdUsuario(\AppBundle\Entity\TUsuario $idUsuario = null)
    {
        $this->idUsuario = $idUsuario;

        return $this;
    }

    /**
     * Get idUsuario
     *
     * @return \AppBundle\Entity\TUsuario
     */
    public function getIdUsuario()
    {
        return $this->idUsuario;
    }
}

