<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * TCurso
 *
 * @ORM\Table(name="t_curso")
 * @ORM\Entity
 */
class TCurso
{
    /**
     * @var \DateTime
     * @Assert\NotBlank()
     */
    private $fechaInicio;

    /**
     * @var \DateTime
     * @Assert\NotBlank()
     */
    private $fechaFin;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $paralelo;

    /**
     * @var integer
     * @Assert\NotBlank()
     */
    private $participantesProg;

    /**
     * @var \DateTime
     */
    private $fechaIniEfectivo;

    /**
     * @var \DateTime
     */
    private $fechaFinEfectivo;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $dias;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $horas;

    /**
     * @var integer
     * @Assert\NotBlank()
     */
    private $totalHoras;

    /**
     * @var integer
     */
    private $horasClases;

    /**
     * @var integer
     */
    private $idCurso;

    /**
     * @var \AppBundle\Entity\TUsuario
     * @Assert\NotBlank()
     */
    private $idUsuario;

    /**
     * @var \AppBundle\Entity\TTurno
     * @Assert\NotBlank()
     */
    private $idTurno;

    /**
     * @var \AppBundle\Entity\TPeriodo
     * @Assert\NotBlank()
     */
    private $idPeriodo;

    /**
     * @var \AppBundle\Entity\TCarrera
     * @Assert\NotBlank()
     */
    private $idCarrera;


    /**
     * Set fechaInicio
     *
     * @param \DateTime $fechaInicio
     *
     * @return TCurso
     */
    public function setFechaInicio($fechaInicio)
    {
        $this->fechaInicio = $fechaInicio;

        return $this;
    }

    /**
     * Get fechaInicio
     *
     * @return \DateTime
     */
    public function getFechaInicio()
    {
        return $this->fechaInicio;
    }

    /**
     * Set fechaFin
     *
     * @param \DateTime $fechaFin
     *
     * @return TCurso
     */
    public function setFechaFin($fechaFin)
    {
        $this->fechaFin = $fechaFin;

        return $this;
    }

    /**
     * Get fechaFin
     *
     * @return \DateTime
     */
    public function getFechaFin()
    {
        return $this->fechaFin;
    }

    /**
     * Set paralelo
     *
     * @param string $paralelo
     *
     * @return TCurso
     */
    public function setParalelo($paralelo)
    {
        $this->paralelo = $paralelo;

        return $this;
    }

    /**
     * Get paralelo
     *
     * @return string
     */
    public function getParalelo()
    {
        return $this->paralelo;
    }

    /**
     * Set participantesProg
     *
     * @param integer $participantesProg
     *
     * @return TCurso
     */
    public function setParticipantesProg($participantesProg)
    {
        $this->participantesProg = $participantesProg;

        return $this;
    }

    /**
     * Get participantesProg
     *
     * @return integer
     */
    public function getParticipantesProg()
    {
        return $this->participantesProg;
    }

    /**
     * Set fechaIniEfectivo
     *
     * @param \DateTime $fechaIniEfectivo
     *
     * @return TCurso
     */
    public function setFechaIniEfectivo($fechaIniEfectivo)
    {
        $this->fechaIniEfectivo = $fechaIniEfectivo;

        return $this;
    }

    /**
     * Get fechaIniEfectivo
     *
     * @return \DateTime
     */
    public function getFechaIniEfectivo()
    {
        return $this->fechaIniEfectivo;
    }

    /**
     * Set fechaFinEfectivo
     *
     * @param \DateTime $fechaFinEfectivo
     *
     * @return TCurso
     */
    public function setFechaFinEfectivo($fechaFinEfectivo)
    {
        $this->fechaFinEfectivo = $fechaFinEfectivo;

        return $this;
    }

    /**
     * Get fechaFinEfectivo
     *
     * @return \DateTime
     */
    public function getFechaFinEfectivo()
    {
        return $this->fechaFinEfectivo;
    }

    /**
     * Set dias
     *
     * @param string $dias
     *
     * @return TCurso
     */
    public function setDias($dias)
    {
	    $dias_json=json_encode($dias);
	    return $this->dias = $dias_json;

//        $this->dias = $dias;
//        return $this;
    }

    /**
     * Get dias
     *
     * @return string
     */
    public function getDias()
    {
	    $dias=json_decode($this->dias);
	    return $dias;

//        return $this->dias;
    }

    /**
     * Set horas
     *
     * @param string $horas
     *
     * @return TCurso
     */
    public function setHoras($horas)
    {
        $this->horas = $horas;

        return $this;
    }

    /**
     * Get horas
     *
     * @return string
     */
    public function getHoras()
    {
        return $this->horas;
    }

    /**
     * Set totalHoras
     *
     * @param integer $totalHoras
     *
     * @return TCurso
     */
    public function setTotalHoras($totalHoras)
    {
        $this->totalHoras = $totalHoras;

        return $this;
    }

    /**
     * Get totalHoras
     *
     * @return integer
     */
    public function getTotalHoras()
    {
        return $this->totalHoras;
    }

    /**
     * Set horasClases
     *
     * @param integer $horasClases
     *
     * @return TCurso
     */
    public function setHorasClases($horasClases)
    {
        $this->horasClases = $horasClases;

        return $this;
    }

    /**
     * Get horasClases
     *
     * @return integer
     */
    public function getHorasClases()
    {
        return $this->horasClases;
    }

    /**
     * Get idCurso
     *
     * @return integer
     */
    public function getIdCurso()
    {
        return $this->idCurso;
    }

    /**
     * Set idUsuario
     *
     * @param \AppBundle\Entity\TUsuario $idUsuario
     *
     * @return TCurso
     */
    public function setIdUsuario(\AppBundle\Entity\TUsuario $idUsuario = null)
    {
        $this->idUsuario = $idUsuario;

        return $this;
    }

    /**
     * Get idUsuario
     *
     * @return \AppBundle\Entity\TUsuario
     */
    public function getIdUsuario()
    {
        return $this->idUsuario;
    }

    /**
     * Set idTurno
     *
     * @param \AppBundle\Entity\TTurno $idTurno
     *
     * @return TCurso
     */
    public function setIdTurno(\AppBundle\Entity\TTurno $idTurno = null)
    {
        $this->idTurno = $idTurno;

        return $this;
    }

    /**
     * Get idTurno
     *
     * @return \AppBundle\Entity\TTurno
     */
    public function getIdTurno()
    {
        return $this->idTurno;
    }

    /**
     * Set idPeriodo
     *
     * @param \AppBundle\Entity\TPeriodo $idPeriodo
     *
     * @return TCurso
     */
    public function setIdPeriodo(\AppBundle\Entity\TPeriodo $idPeriodo = null)
    {
        $this->idPeriodo = $idPeriodo;

        return $this;
    }

    /**
     * Get idPeriodo
     *
     * @return \AppBundle\Entity\TPeriodo
     */
    public function getIdPeriodo()
    {
        return $this->idPeriodo;
    }

    /**
     * Set idCarrera
     *
     * @param \AppBundle\Entity\TCarrera $idCarrera
     *
     * @return TCurso
     */
    public function setIdCarrera(\AppBundle\Entity\TCarrera $idCarrera = null)
    {
        $this->idCarrera = $idCarrera;

        return $this;
    }

    /**
     * Get idCarrera
     *
     * @return \AppBundle\Entity\TCarrera
     */
    public function getIdCarrera()
    {
        return $this->idCarrera;
    }

	public function __toString()
	{
		return $this->getParalelo();
	}
}
