<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * TEvaluacion
 *
 * @ORM\Table(name="t_evaluacion", indexes={@ORM\Index(name="id_curso", columns={"id_curso"})})
 * @ORM\Entity
 */
class TEvaluacion
{
    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $titulo;

    /**
     * @var integer
     * @Assert\NotBlank()
     */
    private $numeroPreguntas;

    /**
     * @var \DateTime
     */
    private $fechaCreacion;

    /**
     * @var \DateTime
     * @Assert\NotBlank()
     */
    private $fechaInicio;

    /**
     * @var \DateTime
     * @Assert\NotBlank()
     */
    private $fechaFin;

    /**
     * @var integer
     * @Assert\NotBlank()
     */
    private $minutos;

    /**
     * @var boolean
     */
    private $activo;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_evaluacion", type="smallint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idEvaluacion;


    /**
     * @var \TCurso
     *
     * @ORM\ManyToOne(targetEntity="TCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_curso", referencedColumnName="id_curso")
     * })
     */
    private $idCurso;


    /**
     * Set titulo
     *
     * @param string $titulo
     *
     * @return TEvaluacion
     */
    public function setTitulo($titulo)
    {
        $this->titulo = $titulo;

        return $this;
    }

    /**
     * Get titulo
     *
     * @return string
     */
    public function getTitulo()
    {
        return $this->titulo;
    }

    /**
     * Set numeroPreguntas
     *
     * @param integer $numeroPreguntas
     *
     * @return TEvaluacion
     */
    public function setNumeroPreguntas($numeroPreguntas)
    {
        $this->numeroPreguntas = $numeroPreguntas;

        return $this;
    }

    /**
     * Get numeroPreguntas
     *
     * @return integer
     */
    public function getNumeroPreguntas()
    {
        return $this->numeroPreguntas;
    }

    /**
     * Set fechaCreacion
     *
     * @param \DateTime $fechaCreacion
     *
     * @return TEvaluacion
     */
    public function setFechaCreacion($fechaCreacion)
    {
        $this->fechaCreacion = $fechaCreacion;

        return $this;
    }

    /**
     * Get fechaCreacion
     *
     * @return \DateTime
     */
    public function getFechaCreacion()
    {
        return $this->fechaCreacion;
    }

    /**
     * Set fechaInicio
     *
     * @param \DateTime $fechaInicio
     *
     * @return TEvaluacion
     */
    public function setFechaInicio($fechaInicio)
    {
        $this->fechaInicio = $fechaInicio;

        return $this;
    }

    /**
     * Get fechaInicio
     *
     * @return \DateTime
     */
    public function getFechaInicio()
    {
        return $this->fechaInicio;
    }

    /**
     * Set fechaFin
     *
     * @param \DateTime $fechaFin
     *
     * @return TEvaluacion
     */
    public function setFechaFin($fechaFin)
    {
        $this->fechaFin = $fechaFin;

        return $this;
    }

    /**
     * Get fechaFin
     *
     * @return \DateTime
     */
    public function getFechaFin()
    {
        return $this->fechaFin;
    }

    /**
     * Set minutos
     *
     * @param integer $minutos
     *
     * @return TEvaluacion
     */
    public function setMinutos($minutos)
    {
        $this->minutos = $minutos;

        return $this;
    }

    /**
     * Get minutos
     *
     * @return integer
     */
    public function getMinutos()
    {
        return $this->minutos;
    }

    /**
     * Set activo
     *
     * @param boolean $activo
     *
     * @return TEvaluacion
     */
    public function setActivo($activo)
    {
        $this->activo = $activo;

        return $this;
    }

    /**
     * Get activo
     *
     * @return boolean
     */
    public function getActivo()
    {
        return $this->activo;
    }

    /**
     * Get idEvaluacion
     *
     * @return integer
     */
    public function getIdEvaluacion()
    {
        return $this->idEvaluacion;
    }

    /**
     * Set idCurso
     *
     * @param \AppBundle\Entity\TCurso $idCurso
     *
     * @return TEvaluacion
     */
    public function setIdCurso(\AppBundle\Entity\TCurso $idCurso = null)
    {
        $this->idCurso = $idCurso;

        return $this;
    }

    /**
     * Get idCurso
     *
     * @return \AppBundle\Entity\TCurso
     */
    public function getIdCurso()
    {
        return $this->idCurso;
    }
}
