<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * TInscripcion
 *
 * @ORM\Table(name="t_inscripcion", indexes={@ORM\Index(name="id_curso", columns={"id_curso"}), @ORM\Index(name="id_estado", columns={"id_estado"}), @ORM\Index(name="id_estudiante", columns={"id_estudiante"}), @ORM\Index(name="id_periodo", columns={"id_periodo"}), @ORM\Index(name="id_usuario", columns={"id_usuario"})})
 * @ORM\Entity
 */
class TInscripcion
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_inscripcion", type="smallint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idInscripcion;

    /**
     * @var integer
     *
     * @ORM\Column(name="asistencia", type="smallint", nullable=true)
     */
    private $asistencia;

    /**
     * @var integer
     *
     * @ORM\Column(name="nota", type="smallint", nullable=true)
     */
    private $nota;

	/**
	 * @var integer
	 *
	 * @ORM\Column(name="transversal", type="smallint", nullable=true)
	 */
	private $transversal;

    /**
     * @var \TCurso
     *
     * @ORM\ManyToOne(targetEntity="TCurso")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_curso", referencedColumnName="id_curso")
     * })
     */
    private $idCurso;

    /**
     * @var \TEstado
     *
     * @ORM\ManyToOne(targetEntity="TEstado")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_estado", referencedColumnName="id_estado")
     * })
     */
    private $idEstado;

    /**
     * @var \TEstudiante
     *
     * @ORM\ManyToOne(targetEntity="TEstudiante")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_estudiante", referencedColumnName="id_estudiante")
     * })
     */
    private $idEstudiante;


    /**
     * @var \TUsuario
     *
     * @ORM\ManyToOne(targetEntity="TUsuario")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_usuario", referencedColumnName="id_usuario")
     * })
     */
    private $idUsuario;



    /**
     * Set asistencia
     *
     * @param integer $asistencia
     *
     * @return TInscripcion
     */
    public function setAsistencia($asistencia)
    {
        $this->asistencia = $asistencia;

        return $this;
    }

    /**
     * Get asistencia
     *
     * @return integer
     */
    public function getAsistencia()
    {
        return $this->asistencia;
    }

    /**
     * Set nota
     *
     * @param integer $nota
     *
     * @return TInscripcion
     */
    public function setNota($nota)
    {
        $this->nota = $nota;

        return $this;
    }

    /**
     * Get nota
     *
     * @return integer
     */
    public function getNota()
    {
        return $this->nota;
    }


	/**
	 * Set transversal
	 *
	 * @param integer $nota
	 *
	 * @return TInscripcion
	 */
	public function setTransversal($transversal)
	{
		$this->transversal = $transversal;

		return $this;
	}

	/**
	 * Get transversal
	 *
	 * @return integer
	 */
	public function getTransversal()
	{
		return $this->transversal;
	}


    /**
     * Get idInscripcion
     *
     * @return integer
     */
    public function getIdInscripcion()
    {
        return $this->idInscripcion;
    }


    /**
     * Set idUsuario
     *
     * @param \AppBundle\Entity\TUsuario $idUsuario
     *
     * @return TInscripcion
     */
    public function setIdUsuario(\AppBundle\Entity\TUsuario $idUsuario = null)
    {
        $this->idUsuario = $idUsuario;

        return $this;
    }

    /**
     * Get idUsuario
     *
     * @return \AppBundle\Entity\TUsuario
     */
    public function getIdUsuario()
    {
        return $this->idUsuario;
    }

    /**
     * Set idEstado
     *
     * @param \AppBundle\Entity\TEstado $idEstado
     *
     * @return TInscripcion
     */
    public function setIdEstado(\AppBundle\Entity\TEstado $idEstado = null)
    {
        $this->idEstado = $idEstado;

        return $this;
    }

    /**
     * Get idEstado
     *
     * @return \AppBundle\Entity\TEstado
     */
    public function getIdEstado()
    {
        return $this->idEstado;
    }

    /**
     * Set idEstudiante
     *
     * @param \AppBundle\Entity\TEstudiante $idEstudiante
     *
     * @return TInscripcion
     */
    public function setIdEstudiante(\AppBundle\Entity\TEstudiante $idEstudiante = null)
    {
        $this->idEstudiante = $idEstudiante;

        return $this;
    }

    /**
     * Get idEstudiante
     *
     * @return \AppBundle\Entity\TEstudiante
     */
    public function getIdEstudiante()
    {
        return $this->idEstudiante;
    }

    /**
     * Set idCurso
     *
     * @param \AppBundle\Entity\TCurso $idCurso
     *
     * @return TInscripcion
     */
    public function setIdCurso(\AppBundle\Entity\TCurso $idCurso = null)
    {
        $this->idCurso = $idCurso;

        return $this;
    }

    /**
     * Get idCurso
     *
     * @return \AppBundle\Entity\TCurso
     */
    public function getIdCurso()
    {
        return $this->idCurso;
    }
}
