<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * TPeriodo
 *
 * @ORM\Table(name="t_periodo")
 * @ORM\Entity
 */
class TPeriodo
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_periodo", type="smallint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPeriodo;

    /**
     * @var string
     *
     * @ORM\Column(name="semestre", type="string", length=50, nullable=false)
     * @Assert\NotBlank()
     */
    private $semestre;

    /**
     * @var string
     *
     * @ORM\Column(name="gestion", type="string", length=4, nullable=false)
     * @Assert\NotBlank()
     */
    private $gestion;

    /**
     * @var boolean
     *
     * @ORM\Column(name="activo", type="boolean", nullable=true)
     */
    private $activo;



    /**
     * Set semestre
     *
     * @param string $semestre
     *
     * @return TPeriodo
     */
    public function setSemestre($semestre)
    {
        $this->semestre = $semestre;

        return $this;
    }

    /**
     * Get semestre
     *
     * @return string
     */
    public function getSemestre()
    {
        return $this->semestre;
    }

    /**
     * Set gestion
     *
     * @param string $gestion
     *
     * @return TPeriodo
     */
    public function setGestion($gestion)
    {
        $this->gestion = $gestion;

        return $this;
    }

    /**
     * Get gestion
     *
     * @return string
     */
    public function getGestion()
    {
        return $this->gestion;
    }

    /**
     * Set activo
     *
     * @param boolean $activo
     *
     * @return TPeriodo
     */
    public function setActivo($activo)
    {
        $this->activo = $activo;

        return $this;
    }

    /**
     * Get activo
     *
     * @return boolean
     */
    public function getActivo()
    {
        return $this->activo;
    }

    /**
     * Get idPeriodo
     *
     * @return integer
     */
    public function getIdPeriodo()
    {
        return $this->idPeriodo;
    }

	public function __toString()
	{
		return $this->getGestion() . ' - ' . $this->getSemestre();
	}
}
