<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;


/**
 * TPregunta
 *
 * @ORM\Table(name="t_pregunta", indexes={@ORM\Index(name="id_evaluacion", columns={"id_evaluacion"})})
 * @ORM\Entity
 */
class TPregunta
{
    /**
     * @var integer
     */
    private $numeroPregunta;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $pregunta;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $alternativa1;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $alternativa2;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $alternativa3;

    /**
     * @var integer
     * @Assert\NotBlank()
     */
    private $puntaje;

    /**
     * @var string
     * @Assert\NotBlank()
     */
    private $respuestaCorrecta;

    /**
     * @var boolean
     */
    private $activo;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_pregunta", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idPregunta;

    /**
     * @var \AppBundle\Entity\TEvaluacion
     *
     * @ORM\ManyToOne(targetEntity="TEvaluacion")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_evaluacion", referencedColumnName="id_evaluacion")
     * })
     */
    private $idEvaluacion;


    /**
     * Set numeroPregunta
     *
     * @param integer $numeroPregunta
     *
     * @return TPregunta
     */
    public function setNumeroPregunta($numeroPregunta)
    {
        $this->numeroPregunta = $numeroPregunta;

        return $this;
    }

    /**
     * Get numeroPregunta
     *
     * @return integer
     */
    public function getNumeroPregunta()
    {
        return $this->numeroPregunta;
    }

    /**
     * Set pregunta
     *
     * @param string $pregunta
     *
     * @return TPregunta
     */
    public function setPregunta($pregunta)
    {
        $this->pregunta = $pregunta;

        return $this;
    }

    /**
     * Get pregunta
     *
     * @return string
     */
    public function getPregunta()
    {
        return $this->pregunta;
    }

    /**
     * Set alternativa1
     *
     * @param string $alternativa1
     *
     * @return TPregunta
     */
    public function setAlternativa1($alternativa1)
    {
        $this->alternativa1 = $alternativa1;

        return $this;
    }

    /**
     * Get alternativa1
     *
     * @return string
     */
    public function getAlternativa1()
    {
        return $this->alternativa1;
    }

    /**
     * Set alternativa2
     *
     * @param string $alternativa2
     *
     * @return TPregunta
     */
    public function setAlternativa2($alternativa2)
    {
        $this->alternativa2 = $alternativa2;

        return $this;
    }

    /**
     * Get alternativa2
     *
     * @return string
     */
    public function getAlternativa2()
    {
        return $this->alternativa2;
    }

    /**
     * Set alternativa3
     *
     * @param string $alternativa3
     *
     * @return TPregunta
     */
    public function setAlternativa3($alternativa3)
    {
        $this->alternativa3 = $alternativa3;

        return $this;
    }

    /**
     * Get alternativa3
     *
     * @return string
     */
    public function getAlternativa3()
    {
        return $this->alternativa3;
    }

    /**
     * Set puntaje
     *
     * @param integer $puntaje
     *
     * @return TPregunta
     */
    public function setPuntaje($puntaje)
    {
        $this->puntaje = $puntaje;

        return $this;
    }

    /**
     * Get puntaje
     *
     * @return integer
     */
    public function getPuntaje()
    {
        return $this->puntaje;
    }

    /**
     * Set respuestaCorrecta
     *
     * @param string $respuestaCorrecta
     *
     * @return TPregunta
     */
    public function setRespuestaCorrecta($respuestaCorrecta)
    {
        $this->respuestaCorrecta = $respuestaCorrecta;

        return $this;
    }

    /**
     * Get respuestaCorrecta
     *
     * @return string
     */
    public function getRespuestaCorrecta()
    {
        return $this->respuestaCorrecta;
    }

    /**
     * Set activo
     *
     * @param boolean $activo
     *
     * @return TPregunta
     */
    public function setActivo($activo)
    {
        $this->activo = $activo;

        return $this;
    }

    /**
     * Get activo
     *
     * @return boolean
     */
    public function getActivo()
    {
        return $this->activo;
    }

    /**
     * Get idPregunta
     *
     * @return integer
     */
    public function getIdPregunta()
    {
        return $this->idPregunta;
    }

    /**
     * Set idEvaluacion
     *
     * @param \AppBundle\Entity\TEvaluacion $idEvaluacion
     *
     * @return TPregunta
     */
    public function setIdEvaluacion(\AppBundle\Entity\TEvaluacion $idEvaluacion = null)
    {
        $this->idEvaluacion = $idEvaluacion;

        return $this;
    }

    /**
     * Get idEvaluacion
     *
     * @return \AppBundle\Entity\TEvaluacion
     */
    public function getIdEvaluacion()
    {
        return $this->idEvaluacion;
    }
}
