<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * TRespuesta
 *
 * @ORM\Table(name="t_respuesta", indexes={@ORM\Index(name="id_pregunta", columns={"id_pregunta"}), indexes={@ORM\Index(name="id_inscripcion", columns={"id_inscripcion"}), indexes={@ORM\Index(name="id_evaluacion", columns={"id_evaluacion"}) })
 * @ORM\Entity
 */
class TRespuesta
{
    /**
     * @var string
     */
    private $respuesta;

    /**
     * @var integer
     */
    private $puntajeObtenido;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_respuesta", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRespuesta;

    /**
     * @var \AppBundle\Entity\TPregunta
     *
     * @ORM\ManyToOne(targetEntity="TPregunta")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_pregunta", referencedColumnName="id_pregunta")
     * })
     */
    private $idPregunta;

    /**
     * @var \AppBundle\Entity\TInscripcion
     *
     * @ORM\ManyToOne(targetEntity="TInscripcion")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_inscripcion", referencedColumnName="id_inscripcion")
     * })
     */
    private $idInscripcion;

    /**
     * @var \AppBundle\Entity\TEvaluacion
     *
     * @ORM\ManyToOne(targetEntity="TEvaluacion")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_evaluacion", referencedColumnName="id_evaluacion")
     * })
     */
    private $idEvaluacion;


    /**
     * Set respuesta
     *
     * @param string $respuesta
     *
     * @return TRespuesta
     */
    public function setRespuesta($respuesta)
    {
        $this->respuesta = $respuesta;

        return $this;
    }

    /**
     * Get respuesta
     *
     * @return string
     */
    public function getRespuesta()
    {
        return $this->respuesta;
    }

    /**
     * Set puntajeObtenido
     *
     * @param integer $puntajeObtenido
     *
     * @return TRespuesta
     */
    public function setPuntajeObtenido($puntajeObtenido)
    {
        $this->puntajeObtenido = $puntajeObtenido;

        return $this;
    }

    /**
     * Get puntajeObtenido
     *
     * @return integer
     */
    public function getPuntajeObtenido()
    {
        return $this->puntajeObtenido;
    }

    /**
     * Get idRespuesta
     *
     * @return integer
     */
    public function getIdRespuesta()
    {
        return $this->idRespuesta;
    }

    /**
     * Set idPregunta
     *
     * @param \AppBundle\Entity\TPregunta $idPregunta
     *
     * @return TRespuesta
     */
    public function setIdPregunta(\AppBundle\Entity\TPregunta $idPregunta = null)
    {
        $this->idPregunta = $idPregunta;

        return $this;
    }

    /**
     * Get idPregunta
     *
     * @return \AppBundle\Entity\TPregunta
     */
    public function getIdPregunta()
    {
        return $this->idPregunta;
    }

    /**
     * Set idInscripcion
     *
     * @param \AppBundle\Entity\TInscripcion $idInscripcion
     *
     * @return TRespuesta
     */
    public function setIdInscripcion(\AppBundle\Entity\TInscripcion $idInscripcion = null)
    {
        $this->idInscripcion = $idInscripcion;

        return $this;
    }

    /**
     * Get idInscripcion
     *
     * @return \AppBundle\Entity\TInscripcion
     */
    public function getIdInscripcion()
    {
        return $this->idInscripcion;
    }

    /**
     * Set idEvaluacion
     *
     * @param \AppBundle\Entity\TEvaluacion $idEvaluacion
     *
     * @return TRespuesta
     */
    public function setIdEvaluacion(\AppBundle\Entity\TEvaluacion $idEvaluacion = null)
    {
        $this->idEvaluacion = $idEvaluacion;

        return $this;
    }

    /**
     * Get idEvaluacion
     *
     * @return \AppBundle\Entity\TEvaluacion
     */
    public function getIdEvaluacion()
    {
        return $this->idEvaluacion;
    }
}
