<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * TUsuario
 *
 * @ORM\Table(name="t_usuario", uniqueConstraints={@ORM\UniqueConstraint(name="UQ_t_usuario_username", columns={"username"})}, indexes={@ORM\Index(name="id_rol", columns={"id_rol"})})
 * @ORM\Entity
 * @UniqueEntity("username")
 */
class TUsuario implements UserInterface
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_usuario", type="smallint", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idUsuario;

    /**
     * @var string
     *
     * @ORM\Column(name="username", type="string", length=50, nullable=false)
     * @Assert\NotBlank()
     */
    private $username;

	/**
	 * @var string
	 * @Assert\NotBlank()
	 */
	private $uscarnet;

    /**
     * @var string
     *
     * @ORM\Column(name="password", type="string", length=64, nullable=false)
     */
    private $password;

    /**
     * @var integer
     *
     * @ORM\Column(name="usCelular", type="integer", nullable=false)
     * @Assert\NotBlank()
     */
    private $uscelular;

    /**
     * @var string
     *
     * @ORM\Column(name="usCorreo", type="string", length=80, nullable=true)
     * @Assert\Email()
     */
    private $uscorreo;

    /**
     * @var string
     *
     * @ORM\Column(name="usFoto", type="string", length=50, nullable=true)
     */
    private $usfoto;

    /**
     * @var string
     *
     * @ORM\Column(name="usNombres", type="string", length=100, nullable=false)
     * @Assert\NotBlank()
     */
    private $usnombres;

    /**
     * @var string
     *
     * @ORM\Column(name="usDomicilio", type="string", length=250, nullable=true)
     * @Assert\NotBlank()
     */
    private $usdomicilio;

    /**
     * @var string
     *
     * @ORM\Column(name="usObservacion", type="string", length=250, nullable=true)
     */
    private $usobservacion;

    /**
     * @var boolean
     *
     * @ORM\Column(name="usEstado", type="boolean", nullable=true)
     */
    private $usestado;

    /**
     * @var \TRol
     *
     * @ORM\ManyToOne(targetEntity="TRol")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_rol", referencedColumnName="id_rol")
     * })
     * @Assert\NotBlank()
     */
    private $idRol;



    /**
     * Set username
     *
     * @param string $username
     *
     * @return TUsuario
     */
    public function setUsername($username)
    {
        $this->username = $username;

        return $this;
    }

    /**
     * Get username
     *
     * @return string
     */
    public function getUsername()
    {
        return $this->username;
    }

    /**
     * Set password
     *
     * @param string $password
     *
     * @return TUsuario
     */
    public function setPassword($password)
    {
        $this->password = $password;

        return $this;
    }

    /**
     * Get password
     *
     * @return string
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * Set uscelular
     *
     * @param integer $uscelular
     *
     * @return TUsuario
     */
    public function setUscelular($uscelular)
    {
        $this->uscelular = $uscelular;

        return $this;
    }

    /**
     * Get uscelular
     *
     * @return integer
     */
    public function getUscelular()
    {
        return $this->uscelular;
    }

    /**
     * Set uscorreo
     *
     * @param string $uscorreo
     *
     * @return TUsuario
     */
    public function setUscorreo($uscorreo)
    {
        $this->uscorreo = $uscorreo;

        return $this;
    }

    /**
     * Get uscorreo
     *
     * @return string
     */
    public function getUscorreo()
    {
        return $this->uscorreo;
    }

    /**
     * Set usfoto
     *
     * @param string $usfoto
     *
     * @return TUsuario
     */
    public function setUsfoto($usfoto)
    {
        $this->usfoto = $usfoto;

        return $this;
    }

    /**
     * Get usfoto
     *
     * @return string
     */
    public function getUsfoto()
    {
        return $this->usfoto;
    }

    /**
     * Set usnombres
     *
     * @param string $usnombres
     *
     * @return TUsuario
     */
    public function setUsnombres($usnombres)
    {
        $this->usnombres = $usnombres;

        return $this;
    }

    /**
     * Get usnombres
     *
     * @return string
     */
    public function getUsnombres()
    {
        return $this->usnombres;
    }

	/**
	 * Set uscarnet
	 *
	 * @param string $uscarnet
	 *
	 * @return Tusuario
	 */
	public function setUscarnet($uscarnet)
	{
		$this->uscarnet = $uscarnet;

		return $this;
	}

	/**
	 * Get uscarnet
	 *
	 * @return string
	 */
	public function getUscarnet()
	{
		return $this->uscarnet;
	}

    /**
     * Set usdomicilio
     *
     * @param string $usdomicilio
     *
     * @return TUsuario
     */
    public function setUsdomicilio($usdomicilio)
    {
        $this->usdomicilio = $usdomicilio;

        return $this;
    }

    /**
     * Get usdomicilio
     *
     * @return string
     */
    public function getUsdomicilio()
    {
        return $this->usdomicilio;
    }

    /**
     * Set usobservacion
     *
     * @param string $usobservacion
     *
     * @return TUsuario
     */
    public function setUsobservacion($usobservacion)
    {
        $this->usobservacion = $usobservacion;

        return $this;
    }

    /**
     * Get usobservacion
     *
     * @return string
     */
    public function getUsobservacion()
    {
        return $this->usobservacion;
    }

    /**
     * Set usestado
     *
     * @param boolean $usestado
     *
     * @return TUsuario
     */
    public function setUsestado($usestado)
    {
        $this->usestado = $usestado;

        return $this;
    }

    /**
     * Get usestado
     *
     * @return boolean
     */
    public function getUsestado()
    {
        return $this->usestado;
    }

    /**
     * Get idUsuario
     *
     * @return integer
     */
    public function getIdUsuario()
    {
        return $this->idUsuario;
    }

    /**
     * Set idRol
     *
     * @param \AppBundle\Entity\TRol $idRol
     *
     * @return TUsuario
     */
    public function setIdRol(\AppBundle\Entity\TRol $idRol = null)
    {
        $this->idRol = $idRol;

        return $this;
    }

    /**
     * Get idRol
     *
     * @return \AppBundle\Entity\TRol
     */
    public function getIdRol()
    {
        return $this->idRol;
    }

	//METODOS QUE DE DEBE IMPLMENTAR LA ENTITY POR USO DE INTERFACE

	/**
	 * @Assert\NotBlank()
	 * @Assert\Length(max=4096)
	 */
	private $plainPassword;

	/**
	 *
	 * @ORM\Column(type="string", length=256)
	 */
	private $roles;

	public function getPlainPassword()
	{
		return $this->plainPassword;
	}

	public function setPlainPassword($password)
	{
		$this->plainPassword = $password;
	}

	public function getSalt()
	{
		// The bcrypt and argon2i algorithms don't require a separate salt.
		// You *may* need a real salt if you choose a different encoder.
		return null;
	}

	public function setRoles($roles)
	{
		$roles_json=json_encode($roles);
		return $this->roles = $roles_json;
	}

	public function getRoles()
	{
//		return array($this->getIdRol());
//		return array('ROLE_SUPER');
		$roles=json_decode($this->roles);
		return $roles;
	}

	public function eraseCredentials()
	{

	}
	public function __toString()
	{
		return $this->getUsnombres();
	}
}
