<?php

namespace AppBundle\Form;

use AppBundle\Entity\TCivil;

use AppBundle\Entity\TDistrito;

use AppBundle\Entity\TGrado;

use Proxies\__CG__\AppBundle\Entity\TProvincia;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

class TEstudianteType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
	    $Carnet = $options['Carnet'];
        $builder
	        ->add('carnet',TextType::class,
		        array('label'=>'No. de Carnet',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>8, 'onkeypress'=>'return controlnum(event)')))

	        ->add('paterno',TextType::class,
		        array('label'=>'Apellido Paterno',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>30, 'onkeypress'=>'return controllet(event)')))

	        ->add('materno',TextType::class,
		        array('label'=>'Apellido Materno',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>30, 'onkeypress'=>'return controllet(event)')))

	        ->add('nombre',TextType::class,
		        array('label'=>'Nombre(s)',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>50, 'onkeypress'=>'return controllet(event)')))

	        ->add('genero', ChoiceType::class, array(
		        'label'=>'Género',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>100 ),
		        'choices'   => array(
			        'Mujer' => 'M',
		        	'Hombre'   => 'H',
		        ),
		        'multiple'  => false,
	            'expanded' => false,

	        ))

	        ->add('nacimiento',DateType::class, array(
		        'widget'=>'single_text',
		        'html5' => false,
		        'input' => 'datetime',
		        'label'=>'Fecha de Nacimiento',
		        'format'=>'dd/MM/yyyy',
		        'attr'=> ['class'=>'form-control mydatepicker', 'style' => 'margin-bottom:5px','placeholder'=>'dd/mm/yyyy']))

	        ->add('direccion',TextType::class,
		        array('label'=>'Dirección de domicilio',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>150)))

	        ->add('zona',TextType::class,
		        array('label'=>'Zona de domicilio',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>150)))

	        ->add('telefono',TextType::class,
		        array('label'=>'No. de Celular',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>8, 'onkeypress'=>'return controlnum(event)')))

	        ->add('correo', EmailType::class, array(
		        'label'=>'Correo Electrónico: ',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>100)))

	        ->add('idDistrito', EntityType::class, [
		        'label' => 'Distrito',
		        'class' => TDistrito::class,
		        'choice_label' => 'descdistrito',
		        'placeholder' => '--- Escoja un Distrito',])

	        ->add('observaciones',TextType::class,
		        array('label'=>'Observaciones',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>200)))

	        ->add('foto',FileType::class, array(
		        'required'=>true,
		        'attr'=>array('class'=>'form-control dropify', 'style' => 'margin-bottom:10px'),
		        'label'=>'Foto',
		        'data_class'=>null))

	        ->add('idProvincia', EntityType::class, [
		        'label' => 'Lugar de Nacimiento',
		        'class' => TProvincia::class,
		        'choice_label' => 'descprovincia',
		        'placeholder' => '--- Escoja un lugar',])

	        ->add('idGrado', EntityType::class, [
		        'label' => 'Último Grado Académico',
		        'class' => TGrado::class,
		        'choice_label' => 'descgrado',
		        'data' => 1,
		        'placeholder' => '--- Escoge último Grado cursado',])

	        ->add('idCivil', EntityType::class, [
		        'label' => 'Estado Civil',
		        'class' => TCivil::class,
		        'choice_label' => 'desccivil',
		        'data' => 1,
		        'placeholder' => '--- Escoge un estado',])

	        ;
    }


    /**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\TEstudiante',
            'Carnet' => null
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_testudiante';
    }


}
