<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\DateTimeType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class TEvaluacionType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('titulo',TextType::class,
                array('label'=>'Título de la Evaluación',
                    'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>200)))

            ->add('numeroPreguntas',TextType::class,
                array('label'=>'Cantidad de Preguntas',
                    'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>3, 'onkeypress'=>'return controlnum(event)')))

            ->add('fechaInicio', DateTimeType::class, array(
                'input'=>'datetime',
                'date_widget'=>'single_text',
                'time_widget'=>'single_text',
                'label'=>'Fecha de Inicio',
                'format' => 'dd-MM-yyyy',
                'attr'=> ['class'=>'form-control mydatepicker', 'style' => 'margin-bottom:5px','placeholder'=>'dd/mm/yyyy']))

            ->add('fechaFin', DateTimeType::class, array(
                'input'=>'datetime',
                'date_widget'=>'single_text',
                'time_widget'=>'single_text',
                'label'=>'Fecha de Finalización',
                'format' => 'dd-MM-yyyy',
                'attr'=> ['class'=>'form-control mydatepicker', 'style' => 'margin-bottom:5px','placeholder'=>'dd/mm/yyyy']))

            ->add('minutos',TextType::class,
                array('label'=>'Minutos para dar la Evaluación',
                    'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>3, 'onkeypress'=>'return controlnum(event)')))

            ->add('activo',CheckboxType::class, array(
                'required'=>false,
                'label'=>'Activo',
                'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px')))
        ;
    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\TEvaluacion'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_tevaluacion';
    }


}
