<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Validator\Constraints\Choice;

class TInscripcionType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
	    $Cursos = $options['cursos'];
	    $idCurso = $options['idCurso'];
//var_dump(intval(strval($idCurso->getIdCurso()))); exit();

	    $choices = array();
	    foreach($Cursos as $curso)
	    {
	    	$key = $curso['curso'];
	    	$choices[$key] = $curso['idCurso'];
//			var_dump($curso['curso']); exit();
	    }

//			var_dump($choices); exit();

        $builder
	        ->add('idCurso',ChoiceType::class, array(
		        'label'=>'Cursos Habilitados',
		        'choices' => $choices,
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px'),
		        'placeholder' => '----Escoge un Curso',
		        'data' => strval($idCurso->getIdCurso()),
	            'required'=> true))
	        ;
    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\TInscripcion',
            'cursos' => null, 'idCurso' =>null,
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_tinscripcion';
    }


}
