<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;

class TPeriodoType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
	        ->add('semestre', ChoiceType::class, array(
		        'label'=>'Semestre',
		        'placeholder' => 'Escoge una opción',
		        'choices'  => array(
			        'Primer Bimestre' => 'Primer Bimestre',
			        'Segundo Bimestre' => 'Segundo Bimestre',
			        'Tercer Bimestre' => 'Tercer Bimestre',
			        'Cuarto Bimestre' => 'Cuarto Bimestre')))

	        ->add('gestion',TextType::class, array(
		        'label'=>'Gestión',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>4 )))
	        ->add('activo',CheckboxType::class, array(
		        'required'=>false,
		        'label'=>'Activo',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px')));

    }

    /**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\TPeriodo'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_tperiodo';
    }


}
