<?php

namespace AppBundle\Form;

use FOS\CKEditorBundle\Form\Type\CKEditorType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class TPreguntaType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder

            ->add('pregunta',CKEditorType::class, array(
                'label'=>'PREGUNTA',
                'attr'=>array('class'=>'form-control', 'rows' => 3 , 'style' => 'margin-bottom:10px','maxlength'=>10000),
                'config' => array(
//                  color de fondo
                    'uiColor' => '#e2e2e2',
//                  El toolbar puede ser: full, standard, basic
//                    'toolbar' => 'standard',
                    'required' => 'true',
                )
            ))


            ->add('alternativa1',CKEditorType::class, array(
                'label'=>'Respuesta Inciso A)',
                'config' => array(
                    'uiColor' => '#e2e2e2',
//                    'toolbar' => 'standard',
                    'required' => 'true',
                )
            ))

            ->add('alternativa2',CKEditorType::class, array(
                'label'=>'Respuesta Inciso B)',
                'config' => array(
                    'uiColor' => '#e2e2e2',
//                    'toolbar' => 'standard',
                    'required' => 'true',
                )
            ))

            ->add('alternativa3',CKEditorType::class, array(
                'label'=>'Respuesta Inciso C)',
                'config' => array(
                    'uiColor' => '#e2e2e2',
//                    'toolbar' => 'standard',
                    'required' => 'true',
                )
            ))

            ->add('puntaje',TextType::class,
                array('label'=>'Puntaje Asignado',
                    'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>3, 'onkeypress'=>'return controlnum(event)')))

            ->add('respuestaCorrecta', ChoiceType::class, array(
                'label'=>'Inciso Respuesta Correcta',
                'choices' => array(
                    'A)' => 'A',
                    'B)' => 'B',
                    'C)' => 'C',
                    'D) Ninguno' => 'D',
                ),
                'required'    => false,
                'placeholder' => 'Seleccione un Inciso',
                'empty_data'  => null,
                'attr' => array('class' => 'form-control', 'id'=>'inputEmail3')
            ))

            ->add('activo',CheckboxType::class, array(
                'required'=>false,
                'label'=>'Activo',
                'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px')))
        ;
    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\TPregunta'
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_tpregunta';
    }


}
