<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\FileType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

class TUsuarioType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
	    $user = $options['usuario'];
//var_dump($user); exit();
	    if (!$user)
		    $banderaRol = 1;
	    else {
		    if($user == 1)
			    $banderaRol = "%";
		    if($user == 2)
			    $banderaRol = 2;
		    if($user == 3)
			    $banderaRol = 3;
		    if($user == 4)
			    $banderaRol = 4;
            if($user == 5)
                $banderaRol = 5;
	    }


	    $builder
	        ->add('username', TextType::class, array(
		        'label'=>'Usuario',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>50, 'onkeypress'=>'return controllet(event)')))

	        ->add('plainPassword', RepeatedType::class, array(
		        'type' => PasswordType::class,
		        'invalid_message' => 'Las contraseñas deben coincidir.',
		        'options' => array('attr' => array('class' => 'password-field')),
		        'required' => true,
		        'first_options'  => array('label' => 'Contraseña', 'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>15)),
		        'second_options' => array('label' => 'Repita la Contraseña', 'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>15)),
	        ))

	        ->add('uscelular',TextType::class,
		        array('label'=>'No. de Celular',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>8, 'onkeypress'=>'return controlnum(event)')))

	        ->add('uscorreo', EmailType::class, array(
		        'label'=>'Correo Electrónico: ',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>100)))

	        ->add('usfoto',FileType::class, array(
		        'required'=>false, 'attr'=>array('class'=>'form-control dropify', 'style' => 'margin-bottom:10px'),
		        'label'=>'Fotografía Actual', 'data_class'=>null))

	        ->add('usnombres',TextType::class,
		        array('label'=>'Nombres',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>100, 'onkeypress'=>'return controllet(event)')))

		    ->add('uscarnet',TextType::class,
			    array('label'=>'No. de Carnet',
			          'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>8, 'onkeypress'=>'return controlnum(event)')))

	        ->add('usdomicilio',TextType::class,
		        array('label'=>'Dirección domicilio',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>200)))

	        ->add('usobservacion',TextType::class,
		        array('label'=>'Observaciones',
		              'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px', 'maxlength'=>200)))

	        ->add('usestado',CheckboxType::class,
		        array('required'=>false, 'label'=>'Estado','attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px')))

	        ->add('idRol', EntityType::class, [
		        'label' => 'Rol del Usuario',
		        'attr'=>array('class'=>'form-control', 'style' => 'margin-bottom:10px'),
		        'class'=>'AppBundle:TRol',
		        'placeholder' => '---- Escoge un Rol',
		        'query_builder' => function ($er) use ($banderaRol){
//			        global $bandera;
			        return $er->createQueryBuilder('p')
			                  ->select('p') // Entity Rol
			                  ->where('p.idRol like :tipoRol')
			                  ->setParameter('tipoRol', $banderaRol)
				        ;
		        },








	        ]);
    }/**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' => 'AppBundle\Entity\TUsuario',
            'usuario' => null
        ));
    }

    /**
     * {@inheritdoc}
     */
    public function getBlockPrefix()
    {
        return 'appbundle_tusuario';
    }


}
