<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

/**
 * UsuarioRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TusuarioRepository extends EntityRepository
{
	public function loadUserByUsername($username)
	{
		return $this->createQueryBuilder('u')
		            ->where('u.username = :username OR u.email = :email')
		            ->setParameter('username', $username)
		            ->setParameter('email', $username)
		            ->getQuery()
		            ->getOneOrNullResult();
	}

	public function consigueRol($idRol)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a.idUsuario, (a.idRol) as rolid 
								FROM AppBundle:TUsuario a  							    		  
							  	WHERE a.idUsuario = " . $idRol
		            )->getResult();
	}

	public function consigueDato($idUsuario)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a.uscelular, b.psnid,  CONCAT(a.usnombre, ' ', a.usapellido) as nombre, c.crrnombre, b.psncorreo, b.psnobservacion, b.psncurriculum, b.psnestado  
								FROM AppBundle:Tusuario a
								JOIN AppBundle:Tpasante b WITH a.usid = b.usid								
								JOIN AppBundle:Tcarrera c WITH b.crrid = c.crrid
							  	WHERE b.usid = " . $idUsuario
		            )->getResult();
	}

	public function consigueDatos()
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a.uscelular, b.psnid,  CONCAT(a.usnombre, ' ', a.usapellido) as nombre, c.crrnombre, b.psncorreo, b.psnobservacion, b.psncurriculum, b.psnestado  
								FROM AppBundle:Tusuario a
								JOIN AppBundle:Tpasante b WITH a.usid = b.usid
								JOIN AppBundle:Tcarrera c WITH b.crrid = c.crrid"
		            )->getResult();
	}

	public function consigueRoldesc($idUsuario)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT b.roldescripcion 
								FROM AppBundle:Tusuario a
								JOIN AppBundle:Trol b WITH a.rolid = b.rolid  							    		  
							  	WHERE a.usid = " . $idUsuario
		            )->getResult();
	}

	public function consigueDatoSolicitud($idUsuario)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a  
								FROM AppBundle:Tsolicitud a								
							  	WHERE a.usid = " . $idUsuario
		            )->getResult();
	}

	public function consigueDatoSolicitudes()
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a  
								FROM AppBundle:Tsolicitud a "
		            )->getResult();
	}

	public function consigueRequerimiento()
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT (a.solid) as solid  
								FROM AppBundle:Trequerimiento a"
		            )->getResult();
	}

	public function consigueAsignaciones($Estado)
	{
		if ($Estado == "'1'") $Estado = "'1' or e.asgestado LIKE '2'";
		return $this->getEntityManager()
		            ->createQuery(
			            "select (e.asgid) as asgid, (e.psnid) as psnid, (e.reqid) as reqid, (c.crrid) as crrid, a.empnombre, a.emptelefono, b.solinicio, (b.solid) as solid, 
								b.solfin, d.crrnombre, c.reqobjeto, e.asgestado, CONCAT(g.usnombre, ' ', g.usapellido) as nombre
								from AppBundle:Tempresa a
								join AppBundle:Tsolicitud b WITH a.empid = b.empid
								join AppBundle:Trequerimiento c WITH c.solid = b.solid
								join AppBundle:Tcarrera d WITH d.crrid = c.crrid
								join AppBundle:Tasignacion e WITH e.reqid = c.reqid
								left join AppBundle:Tpasante f WITH f.psnid = e.psnid 
								left join AppBundle:Tusuario g WITH f.usid = g.usid 
								where b.solestado = 1 and e.asgestado LIKE " . $Estado
		            )->getResult();
	}

	public function consiguePasantes()
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a  
								FROM AppBundle:Tpasante a 
								join AppBundle:Tusuario g WITH a.usid = g.usid
								WHERE a.psnestado = 1 AND g.rolid=3"
		            )->getResult();
	}

	public function consiguePasante($usId)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT a  
								FROM AppBundle:Tpasante a
								join AppBundle:Tusuario g WITH a.usid = g.usid 
								WHERE g.rolid=3 AND a.psnestado = 1 AND g.usid = " . $usId
		            )->getResult();
	}

	public function actualizaAsignacion($asgid, $psnid)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "UPDATE AppBundle:Tasignacion a SET a.asgestado = 1, a.psnid = ". $psnid ."
			                    WHERE a.asgid = " . $asgid
		            )->getResult();
	}

	public function decideAsignacion($asgid, $bandera)
	{
		if ($bandera ==2)
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:Tasignacion a SET a.asgestado = ". $bandera ."
				                    WHERE a.asgid = " . $asgid
			            )->getResult();
		else
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:Tasignacion a SET a.psnid = null, a.asgestado = ". $bandera ."
				                    WHERE a.asgid = " . $asgid
			            )->getResult();
	}

	public function consigueAsignacionesAsignadas($Rol, $Usuario)
	{
//		if ($Estado == '%') $Estado = "'%'";
		$Usuario = "'".$Usuario."'";
		if ($Rol == 1 or $Rol == 3)
		return $this->getEntityManager()
		            ->createQuery(
			            "select (e.asgid) as asgid, (e.psnid) as psnid, (e.reqid) as reqid, (c.crrid) as crrid, a.empnombre, a.emptelefono, b.solinicio, b.solfin, (b.solid) as solid, 
								d.crrnombre, c.reqobjeto, e.asgestado, CONCAT(g.usnombre, ' ', g.usapellido) as nombre
								from AppBundle:Tempresa a
								join AppBundle:Tsolicitud b WITH a.empid = b.empid
								join AppBundle:Trequerimiento c WITH c.solid = b.solid
								join AppBundle:Tcarrera d WITH d.crrid = c.crrid
								join AppBundle:Tasignacion e WITH e.reqid = c.reqid
								left join AppBundle:Tpasante f WITH f.psnid = e.psnid 
								left join AppBundle:Tusuario g WITH f.usid = g.usid 
								where b.solestado = 1 and e.asgestado = 2 and g.usid LIKE " . $Usuario
		            )->getResult();
		else
			return $this->getEntityManager()
			            ->createQuery(
				            "select (e.asgid) as asgid, (e.psnid) as psnid, (e.reqid) as reqid, (c.crrid) as crrid, a.empnombre, a.emptelefono, b.solinicio, b.solfin, (b.solid) as solid, 
								d.crrnombre, c.reqobjeto, e.asgestado, CONCAT(g.usnombre, ' ', g.usapellido) as nombre
								from AppBundle:Tempresa a
								join AppBundle:Tsolicitud b WITH a.empid = b.empid
								join AppBundle:Trequerimiento c WITH c.solid = b.solid
								join AppBundle:Tcarrera d WITH d.crrid = c.crrid
								join AppBundle:Tasignacion e WITH e.reqid = c.reqid
								left join AppBundle:Tpasante f WITH f.psnid = e.psnid 
								left join AppBundle:Tusuario g WITH f.usid = g.usid 
								where b.solestado = 1 and e.asgestado = 2 and b.usid = " . $Usuario
			            )->getResult();
	}


	public function consigueTareas($usid)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "select (e.asgid) as asgid, (e.psnid) as psnid, (e.reqid) as reqid, (c.crrid) as crrid, a.empnombre, h.tardescripcion, h.tarinicio, h.tarfin, d.crrnombre, h.tarinforme, 
								h.tarfechainforme, h.tarestado, CONCAT(g.usnombre, ' ', g.usapellido) as nombre, h.tarobservacion
								from AppBundle:Tempresa a
								join AppBundle:Tsolicitud b WITH a.empid = b.empid
								join AppBundle:Trequerimiento c WITH c.solid = b.solid
								join AppBundle:Tcarrera d WITH d.crrid = c.crrid
								join AppBundle:Tasignacion e WITH e.reqid = c.reqid
								join AppBundle:Ttarea h WITH h.asgid = e.asgid
								left join AppBundle:Tpasante f WITH f.psnid = e.psnid 
								left join AppBundle:Tusuario g WITH f.usid = g.usid 
								where e.psnid is not null and e.asgestado = 2 and b.solestado = 1 and g.usid LIKE '" . $usid ."'"
		            )->getResult();
	}

	public function consigueTarea()
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "SELECT (a.asgid) as asgid 
								FROM AppBundle:Ttarea a"
		            )->getResult();
	}


	public function consigueAsignacion($asgid)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "select (e.asgid) as asgid, (e.psnid) as psnid, (e.reqid) as reqid, (c.crrid) as crrid, (h.tarid) as tarid, a.empnombre, h.tardescripcion, h.tarinicio, h.tarfin, d.crrnombre, h.tarinforme, 
								h.tarfechainforme, h.tarestado, CONCAT(g.usnombre, ' ', g.usapellido) as nombre, h.tarobservacion, b.solinicio, b.solfin, (g.rolid) as rolid
								from AppBundle:Tempresa a
								join AppBundle:Tsolicitud b WITH a.empid = b.empid
								join AppBundle:Trequerimiento c WITH c.solid = b.solid
								join AppBundle:Tcarrera d WITH d.crrid = c.crrid
								join AppBundle:Tasignacion e WITH e.reqid = c.reqid
								join AppBundle:Ttarea h WITH h.asgid = e.asgid
								left join AppBundle:Tpasante f WITH f.psnid = e.psnid 
								left join AppBundle:Tusuario g WITH f.usid = g.usid 
								where e.psnid is not null and e.asgestado = 2 and b.solestado = 1 and e.asgid = '" . $asgid ."'"
		            )->getResult();
	}

	public function consigueParteAsignacion($asgid)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "select DISTINCT (e.asgid) as asgid, (e.psnid) as psnid, (e.reqid) as reqid, (c.crrid) as crrid, a.empnombre, d.crrnombre, (b.solid) as solid, 
								CONCAT(g.usnombre, ' ', g.usapellido) as nombre, b.solinicio, b.solfin, c.reqobjeto
								from AppBundle:Tempresa a
								join AppBundle:Tsolicitud b WITH a.empid = b.empid
								join AppBundle:Trequerimiento c WITH c.solid = b.solid
								join AppBundle:Tcarrera d WITH d.crrid = c.crrid
								join AppBundle:Tasignacion e WITH e.reqid = c.reqid
								join AppBundle:Ttarea h WITH h.asgid = e.asgid
								left join AppBundle:Tpasante f WITH f.psnid = e.psnid 
								left join AppBundle:Tusuario g WITH f.usid = g.usid 
								where e.psnid is not null and e.asgestado = 2 and b.solestado = 1 and e.asgid = '" . $asgid ."'"
		            )->getResult();
	}


	public function consigueObservacionTarea($tarid)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "select a.tarobservacion as tarobservacion								 
								from AppBundle:Ttarea a  
								where a.tarid = '" . $tarid ."'"
		            )->getResult();
	}

	public function decideTarea($tarid, $bandera, $observacion)
	{

		$fecha = new \DateTime("now");

//		var_dump($observacion[0]['tarobservacion']); exit();

		if ($bandera ==2) {
			$fecha = $observacion[0]['tarobservacion'] . ' Aprobado en Fecha: ' . strval($fecha->format('d/m/Y'));
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:Ttarea a 
									SET a.tarestado = " . $bandera . ", 
									a.tarobservacion = '" . $fecha . "' 
				                    WHERE a.tarid = '" . $tarid . "'"
			            )->getResult();
		}
		else {
			$fecha = $observacion[0]['tarobservacion'] . ' Rechazado en Fecha: ' . strval($fecha->format('d/m/Y'));
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:Ttarea a 
									SET a.tarinforme = null, 
									a.tarfechainforme = null, 
									a.tarobservacion = '" . $fecha . "' , 
									a.tarestado = " . $bandera . "
				                    WHERE a.tarid = '" . $tarid . "'"
			            )->getResult();
		}
	}

	public function borraUsuario($usid)
	{
		return $this->getEntityManager()
		            ->createQuery(
			            "DELETE AppBundle:Tusuario a WHERE a.usid =" .$usid
		            )->getResult();
	}

	// Cuando se quiere hacer un join y sacar su identificador usar parentisis en el selecto: avcodigo, (pycodigo), nombre, etc.
// Presta atención con IDENTITY (prcodigo)

	public function findInscripciones()
	{
		return $this->getEntityManager()
		            ->createQuery("select a.idInscripcion, c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo,
										CONCAT(COALESCE(f.paterno,''), ' ', COALESCE(f.materno,''), ' ', f.nombre) as nombre, f.carnet, 
										(a.idEstudiante) as idEstudiante, a.nota, a.asistencia, g.descEstado 
										from AppBundle:TInscripcion a 
										 join AppBundle:TEstudiante f WITH a.idEstudiante = f.idEstudiante
										 join AppBundle:TCurso b WITH a.idCurso = b.idCurso
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 join AppBundle:TCarrera d WITH d.idCarrera = b.idCarrera
										 join AppBundle:TEstado g WITH g.idEstado = a.idEstado
										 join AppBundle:TTurno e WITH e.idTurno = b.idTurno
										 ORDER BY c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo, nombre"
		            )->getResult();
	}

	public function findInscripcionEstudiante($idEstudiante)
	{
		return $this->getEntityManager()
		            ->createQuery("select c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo,										
										a.nota, a.asistencia, g.descEstado 
										from AppBundle:TInscripcion a 
										 join AppBundle:TEstudiante f WITH a.idEstudiante = f.idEstudiante
										 join AppBundle:TCurso b WITH a.idCurso = b.idCurso
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 join AppBundle:TCarrera d WITH d.idCarrera = b.idCarrera
										 join AppBundle:TEstado g WITH g.idEstado = a.idEstado
										 join AppBundle:TTurno e WITH e.idTurno = b.idTurno
										 WHERE a.idEstudiante = " . $idEstudiante .
										 " ORDER BY c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo"
		            )->getResult();
	}

	public function findCursos($periodoActivo)
	{
		return $this->getEntityManager()
		            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera
										where b.activo = " . $periodoActivo . " order by b.gestion, b.semestre, c.descCarrera "
		            )->getResult();
	}

	public function findCursosProfe($periodoActivo, $usuario)
	{
		if($usuario->getIdRol()->getIdRol() == 1)
			$idUsuario = '';
		else
			$idUsuario = 'AND a.idUsuario = ' . $usuario->getIdUsuario();

		return $this->getEntityManager()
		            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera										 
										where b.activo = " . $periodoActivo . " " . $idUsuario . " 
										order by b.gestion, b.semestre, c.descCarrera "
		            )->getResult();
	}

	public function findTodosCursos($periodoActivo)
	{
		if($periodoActivo = 0)
			return $this->getEntityManager()
		            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera
										 join AppBundle:TInscripcion d WITH d.idCurso = a.idCurso										 
										order by b.gestion DESC, b.semestre, c.descCarrera  "
		            )->getResult();
		else
			return $this->getEntityManager()
			            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera
										 join AppBundle:TInscripcion d WITH d.idCurso = a.idCurso
										 where b.activo = 1										 
										order by b.gestion DESC, b.semestre, c.descCarrera  "
			            )->getResult();
	}

	public function findHijos($idTurno)
	{
		if($idTurno==0)
			return $this->getEntityManager()
		            ->createQuery("select (d.idHijos) as idHijos, CONCAT(e.semestre, ' - ', e.gestion) as periodo, f.descCarrera, g.descTurno, c.paralelo, 
							CONCAT(a.paterno, ' ', a.materno, ' ', a.nombre) as nombre, d.nombreHijo, d.generoHijo, d.edadHijo 
							from AppBundle:TEstudiante a 
							join AppBundle:TInscripcion b WITH a.idEstudiante = b.idEstudiante
							join AppBundle:TCurso c WITH b.idCurso = c.idCurso
							join AppBundle:THijos d WITH d.idEstudiante = a.idEstudiante and d.idPeriodo = c.idPeriodo
							join AppBundle:TPeriodo e WITH e.idPeriodo = c.idPeriodo
							join AppBundle:TCarrera f WITH f.idCarrera = c.idCarrera
							join AppBundle:TTurno g WITH g.idTurno = c.idTurno
							order by c.idPeriodo, c.idCarrera, c.idTurno, c.paralelo, d.nombreHijo"
		            )->getResult();
		else
			return $this->getEntityManager()
			            ->createQuery("select (d.idHijos) as idHijos, CONCAT(e.semestre, ' - ', e.gestion) as periodo, f.descCarrera, g.descTurno, c.paralelo, 
							CONCAT(a.paterno, ' ', a.materno, ' ', a.nombre) as nombre, d.nombreHijo, d.generoHijo, d.edadHijo 
							from AppBundle:TEstudiante a 
							join AppBundle:TInscripcion b WITH a.idEstudiante = b.idEstudiante
							join AppBundle:TCurso c WITH b.idCurso = c.idCurso
							join AppBundle:THijos d WITH d.idEstudiante = a.idEstudiante and d.idPeriodo = c.idPeriodo
							join AppBundle:TPeriodo e WITH e.idPeriodo = c.idPeriodo
							join AppBundle:TCarrera f WITH f.idCarrera = c.idCarrera
							join AppBundle:TTurno g WITH g.idTurno = c.idTurno
							WHERE g.idTurno = ". $idTurno ."
							order by c.idPeriodo, c.idCarrera, c.idTurno, c.paralelo, d.nombreHijo"
			            )->getResult();
	}

	public function findMadres($idCurso)
	{
		return $this->getEntityManager()
		            ->createQuery("select (a.idEstudiante) as idEstudiante, (e.idPeriodo) as idPeriodo, f.descCarrera, g.descTurno, c.paralelo, 
							CONCAT(a.paterno, ' ', a.materno, ' ', a.nombre) as nombre, count(d.idHijos) as Cantidad  
							from AppBundle:TEstudiante a 
							join AppBundle:TInscripcion b WITH a.idEstudiante = b.idEstudiante
							join AppBundle:TCurso c WITH b.idCurso = c.idCurso
							join AppBundle:TPeriodo e WITH e.idPeriodo = c.idPeriodo
							join AppBundle:TCarrera f WITH f.idCarrera = c.idCarrera
							join AppBundle:TTurno g WITH g.idTurno = c.idTurno
							left join AppBundle:THijos d WITH d.idEstudiante = a.idEstudiante and d.idPeriodo = c.idPeriodo
							WHERE c.idCurso = ". $idCurso ."
							GROUP BY a.idEstudiante, e.idPeriodo, e.semestre, e.gestion, f.descCarrera, g.descTurno, c.paralelo
							order by c.paralelo, nombre"
//		            )->getResult();
		            )->getArrayResult();
	}

	public function findParticipantesPeriodo()
	{
		return $this->getEntityManager()
		            ->createQuery("select (a.idEstudiante) as idEstudiante, (e.idPeriodo) as idPeriodo, f.descCarrera, g.descTurno, c.paralelo, 
							CONCAT(a.paterno, ' ', a.materno, ' ', a.nombre) as nombre, count(d.idHijos) as Cantidad  
							from AppBundle:TEstudiante a 
							join AppBundle:TInscripcion b WITH a.idEstudiante = b.idEstudiante
							join AppBundle:TCurso c WITH b.idCurso = c.idCurso
							join AppBundle:TPeriodo e WITH e.idPeriodo = c.idPeriodo
							join AppBundle:TCarrera f WITH f.idCarrera = c.idCarrera
							join AppBundle:TTurno g WITH g.idTurno = c.idTurno
							left join AppBundle:THijos d WITH d.idEstudiante = a.idEstudiante and d.idPeriodo = c.idPeriodo
							WHERE c.idPeriodo = 1
							GROUP BY a.idEstudiante, e.idPeriodo, e.semestre, e.gestion, f.descCarrera, g.descTurno, c.paralelo
							order by c.paralelo, nombre"
		            )->getResult();
//			)->getArrayResult();
	}

	public function findInscripcionesPorCurso($idCurso)
	{

		return $this->getEntityManager()
		            ->createQuery("select a.idInscripcion, (a.idCurso) as idCurso, c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo,
										CONCAT(COALESCE(f.paterno,''), ' ', COALESCE(f.materno,''), ' ', f.nombre) as nombre, f.carnet, 
										(a.idEstudiante) as idEstudiante, a.nota, a.asistencia, g.descEstado, a.transversal 
										from AppBundle:TInscripcion a 
										 join AppBundle:TEstudiante f WITH a.idEstudiante = f.idEstudiante
										 join AppBundle:TCurso b WITH a.idCurso = b.idCurso
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 join AppBundle:TCarrera d WITH d.idCarrera = b.idCarrera
										 join AppBundle:TEstado g WITH g.idEstado = a.idEstado
										 join AppBundle:TTurno e WITH e.idTurno = b.idTurno
										 WHERE a.idCurso = " . $idCurso . "  
										 ORDER BY c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo, nombre"
		            )->getResult();
	}

	public function findInscripcionesCurso($idCurso, $usuario)
	{
//		var_dump($usuario->getIdRol()->getIdRol()); exit();
//		var_dump($usuario->getIdUsuario()); exit();


		if($usuario->getIdRol()->getIdRol() == 1)
			$idUsuario = '';
		else
			$idUsuario = 'AND b.idUsuario = ' . $usuario->getIdUsuario();

//		var_dump($idUsuario); exit();

		return $this->getEntityManager()
		            ->createQuery("select a.idInscripcion, (a.idCurso) as idCurso, c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo,
										CONCAT(COALESCE(f.paterno,''), ' ', COALESCE(f.materno,''), ' ', f.nombre) as nombre, f.carnet, 
										(a.idEstudiante) as idEstudiante, a.nota, a.asistencia, g.descEstado, a.transversal 
										from AppBundle:TInscripcion a 
										 join AppBundle:TEstudiante f WITH a.idEstudiante = f.idEstudiante
										 join AppBundle:TCurso b WITH a.idCurso = b.idCurso
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 join AppBundle:TCarrera d WITH d.idCarrera = b.idCarrera
										 join AppBundle:TEstado g WITH g.idEstado = a.idEstado
										 join AppBundle:TTurno e WITH e.idTurno = b.idTurno
										 WHERE c.activo = 1 AND a.idCurso = " . $idCurso . "  " . $idUsuario . "
										 ORDER BY c.gestion, c.semestre, d.descCarrera, e.descTurno, b.paralelo, nombre"
		            )->getResult();
	}

	public function actualizaEstado($id, $idEstado, $idUsuario, $TipoNota)
	{
		if($TipoNota == 6)
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:TInscripcion a SET a.transversal = ". $idEstado . " 
			                    WHERE a.idInscripcion = " . $id
			            )->getResult();

		if($TipoNota == 7)
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:TInscripcion a SET a.asistencia = ". $idEstado . " 
			                    WHERE a.idInscripcion = " . $id
			            )->getResult();

		if($TipoNota == 8)
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:TInscripcion a SET a.nota = ". $idEstado . " 
			                    WHERE a.idInscripcion = " . $id
			            )->getResult();

		if($TipoNota == 9)
			return $this->getEntityManager()
			            ->createQuery(
				            "UPDATE AppBundle:TInscripcion a SET a.idEstado = ". $idEstado ." , a.idUsuario = " . $idUsuario . "
			                    WHERE a.idInscripcion = " . $id
			            )->getResult();
	}


	public function findInscripcion( $idInscripcion, $idCurso )
	{
	    if (!is_numeric($idInscripcion))
	        $idInscripcion = "'" . $idInscripcion . "'";

		return $this->getEntityManager()
		->createQuery("select b.idInscripcion  
							from AppBundle:TEstudiante a 
							join AppBundle:TInscripcion b WITH a.idEstudiante = b.idEstudiante
							WHERE a.carnet = " .$idInscripcion . " AND b.idCurso = " . $idCurso
		)->getResult();
	}

//	DATOS ESTADÍSTICOS
	public function findInscritos()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, d.descCarrera, count(a) as inscritos 
										FROM AppBundle:TInscripcion a 
										 join AppBundle:TCurso b WITH a.idCurso = b.idCurso
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 JOIN AppBundle:TCarrera d WITH d.idCarrera = b.idCarrera
										GROUP BY c.gestion, c.semestre, d.descCarrera ORDER BY c.gestion, c.semestre, d.descCarrera"
		            )->getResult();
	}

	public function findCursosHoras()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, d.descCarrera, e.descTurno,
										b.paralelo, b.horas, b.totalHoras, b.horasClases 
										FROM AppBundle:TCurso b 
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 JOIN AppBundle:TCarrera d WITH d.idCarrera = b.idCarrera
										 JOIN AppBundle:TTurno e WITH e.idTurno = b.idTurno
										ORDER BY c.gestion, c.semestre, e.descTurno, b.paralelo, d.descCarrera"
		            )->getResult();
	}

	public function findTurnos()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, d.descTurno, count(a) as inscritos 
										FROM AppBundle:TInscripcion a 
										 join AppBundle:TCurso b WITH a.idCurso = b.idCurso
										 join AppBundle:TPeriodo c WITH b.idPeriodo = c.idPeriodo
										 JOIN AppBundle:TTurno d WITH d.idTurno = b.idTurno
										GROUP BY c.gestion, c.semestre, d.descTurno ORDER BY c.gestion, c.semestre, inscritos"
		            )->getResult();
	}

	public function findEtareos()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (SUBSTRING (b.nacimiento,1,4) >= c.gestion-17) THEN 1 ELSE 0 END) AS Menor_a_18,
										SUM(CASE WHEN (SUBSTRING (b.nacimiento,1,4) >= c.gestion-25 AND SUBSTRING (b.nacimiento,1,4) <= c.gestion-18) THEN 1 ELSE 0 END) AS A18_25,
										SUM(CASE WHEN (SUBSTRING (b.nacimiento,1,4) >= c.gestion-32 AND SUBSTRING (b.nacimiento,1,4) <= c.gestion-26) THEN 1 ELSE 0 END) AS A26_32,
										SUM(CASE WHEN (SUBSTRING (b.nacimiento,1,4) >= c.gestion-40 AND SUBSTRING (b.nacimiento,1,4) <= c.gestion-33) THEN 1 ELSE 0 END) AS A33_40,
										SUM(CASE WHEN (SUBSTRING (b.nacimiento,1,4) >= c.gestion-50 AND SUBSTRING (b.nacimiento,1,4) <= c.gestion-41) THEN 1 ELSE 0 END) AS A41_50,
										SUM(CASE WHEN (SUBSTRING (b.nacimiento,1,4) <= c.gestion-51) THEN 1 ELSE 0 END) AS Mayor_a_50 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo										 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}


	public function findEstados()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (a.idEstado =1) THEN 1 ELSE 0 END) AS Aprobado,
										SUM(CASE WHEN (a.idEstado =2) THEN 1 ELSE 0 END) AS Reprobado,
										SUM(CASE WHEN (a.idEstado =3) THEN 1 ELSE 0 END) AS Abandono,
										SUM(CASE WHEN (a.idEstado =4) THEN 1 ELSE 0 END) AS NoAsistio,
										SUM(CASE WHEN (a.idEstado =5) THEN 1 ELSE 0 END) AS Inscrito, count(a) as Total								 
										FROM AppBundle:TInscripcion a										  
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo													 							 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

    public function findEstadosCurso()
    {
        return $this->getEntityManager()
            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, e.descCarrera,
										SUM(CASE WHEN (a.idEstado =1) THEN 1 ELSE 0 END) AS Aprobado,
										SUM(CASE WHEN (a.idEstado =2) THEN 1 ELSE 0 END) AS Reprobado,
										SUM(CASE WHEN (a.idEstado =3) THEN 1 ELSE 0 END) AS Abandono,
										SUM(CASE WHEN (a.idEstado =4) THEN 1 ELSE 0 END) AS NoAsistio,
										SUM(CASE WHEN (a.idEstado =5) THEN 1 ELSE 0 END) AS Inscrito, count(a) as Total								 
										FROM AppBundle:TInscripcion a										  
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo
										 JOIN AppBundle:TCarrera e WITH e.idCarrera = d.idCarrera													 							 
										GROUP BY c.gestion, c.semestre, e.descCarrera ORDER BY c.gestion, c.semestre, e.descCarrera"
            )->getResult();
    }

	public function findCivil()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, e.descCivil, count(a) as inscritos 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo			
										 join AppBundle:TCivil e WITH e.idCivil = b.idCivil							 
										GROUP BY c.gestion, c.semestre, e.descCivil ORDER BY c.gestion, c.semestre, inscritos DESC"
		            )->getResult();
	}

	public function findCantHijos()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (b.hijos ='0') THEN 1 ELSE 0 END) AS H0,
										SUM(CASE WHEN (b.hijos ='1') THEN 1 ELSE 0 END) AS H1,
										SUM(CASE WHEN (b.hijos ='2') THEN 1 ELSE 0 END) AS H2,
										SUM(CASE WHEN (b.hijos ='3') THEN 1 ELSE 0 END) AS H3,
										SUM(CASE WHEN (b.hijos ='4') THEN 1 ELSE 0 END) AS H4,
										SUM(CASE WHEN (b.hijos ='5') THEN 1 ELSE 0 END) AS H5,
										SUM(CASE WHEN (b.hijos ='6') THEN 1 ELSE 0 END) AS H6,
										SUM(CASE WHEN (b.hijos ='7') THEN 1 ELSE 0 END) AS H7,
										SUM(CASE WHEN (b.hijos >='8') THEN 1 ELSE 0 END) AS H8									 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo													 							 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findInformo()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, e.descInformo, count(a) as inscritos 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo			
										  join AppBundle:TInformo e WITH e.idInformo = a.idInformo					 
										GROUP BY c.gestion, c.semestre, e.descInformo ORDER BY c.gestion, c.semestre, inscritos DESC"
		            )->getResult();
	}

	public function findMigrantes()
	{

		$conexion = mysqli_connect( 'localhost', 'juanquimon', "123456" ) or die ("No se ha podido conectar al servidor de Base de datos");
//		$conexion = mysqli_connect( 'localhost', 'naycar5_aladmin', "7*Almalogist" ) or die ("No se ha podido conectar al servidor de Base de datos");
		$db = mysqli_select_db( $conexion, 'bd_mumi') or die ( "Upps! No se ha podido conectar a la base de datos" );
//		$db = mysqli_select_db( $conexion, 'naycar5_mumi') or die ( "Upps! No se ha podido conectar a la base de datos" );

$consulta = "select gestion, 
										 SUM(CASE WHEN id_Provincia not in (1, 2) THEN 1 ELSE 0 END) migrantes1,
										 SUM(CASE WHEN id_Provincia in (1,2) and id_Provincia2 not in(1, 2) THEN 1 ELSE 0 END) migrantes2,
										 SUM(CASE WHEN id_Provincia in (1,2) and id_Provincia2 in(1, 2) THEN 1 ELSE 0 END) noMigrantes,
										count(*) as total from
										(SELECT distinct gestion, b.carnet, b.nombre, b.paterno, b.materno, b.genero, b.nacimiento, j.id_Provincia, k.desc_Tiempo,
										l.id_Provincia as id_Provincia2, h.id_Distrito, g.id_civil, i.id_Grado, 
										b.trabajo, b.dependencia, m.desc_Dependencia,
										b.monto_Apoyo, b.ingreso, f.desc_Categoria, b.violencia as conoceViolencia, b.victima as fueVictima, 
										b.hijos, c.desc_Economico as ocupacion, n.desc_Vivienda								
										FROM t_inscripcion a 
										 JOIN t_estudiante b ON a.id_Estudiante = b.id_Estudiante
										 JOIN t_economico c ON b.id_Economico = c.id_Economico
										 JOIN t_curso d ON d.id_Curso = a.id_Curso
										 JOIN t_turno o ON o.id_Turno = d.id_Turno
										 JOIN t_informo e ON a.id_Informo = e.id_Informo
										 JOIN t_categoria f ON f.id_Categoria = b.id_Categoria
										 JOIN t_civil g ON g.id_Civil = b.id_Civil
										 JOIN t_distrito h ON h.id_Distrito = b.id_Distrito
										 JOIN t_grado i ON i.id_Grado = b.id_Grado
										 JOIN t_provincia j ON j.id_Provincia = b.id_Provincia
										 JOIN t_periodo p ON p.id_Periodo = d.id_Periodo
										 JOIN t_provincia l ON l.id_Provincia = b.id_Provincia2
										 JOIN t_vivienda n ON n.id_Vivienda = b.id_Vivienda
										LEFT JOIN t_tiempo k ON k.id_Tiempo = b.id_Tiempo										 
										LEFT JOIN t_dependencia m ON m.id_Dependencia = b.id_Dependencia										 										
										group by gestion, b.carnet, b.nombre, b.paterno, b.materno, b.genero, b.nacimiento, j.id_Provincia, j.desc_Provincia, k.desc_Tiempo,
										l.id_Provincia, l.desc_Provincia, h.id_Distrito, g.id_Civil, i.id_Grado , 
										b.trabajo, b.dependencia, m.desc_Dependencia,
										b.monto_apoyo, b.ingreso, f.desc_Categoria, b.violencia , b.victima , 
										b.hijos, c.desc_Economico , n.desc_Vivienda) a group by gestion";

		$resultado = mysqli_query( $conexion, $consulta )  or die ( "Algo ha ido mal en la consulta a la base de datos");

		return $resultado;
	}

	public function findDistritos()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, e.descDistrito, count(a) as inscritos 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo			
										 join AppBundle:TDistrito e WITH e.idDistrito = b.idDistrito					 
										GROUP BY c.gestion, c.semestre, e.descDistrito ORDER BY c.gestion, c.semestre, inscritos DESC"
		            )->getResult();
	}

	public function findIngresos()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN b.ingreso >='3001' THEN 1 ELSE 0 END) AS Bs1,
										SUM(CASE WHEN (b.ingreso >='2001' AND b.ingreso <= '3000') THEN 1 ELSE 0 END) AS Bs2,
										SUM(CASE WHEN (b.ingreso >='1001' AND b.ingreso <= '2000') THEN 1 ELSE 0 END) AS Bs3,
										SUM(CASE WHEN (b.ingreso >='501' AND b.ingreso <= '1000') THEN 1 ELSE 0 END) AS Bs4,
										SUM(CASE WHEN b.ingreso <= '500' THEN 1 ELSE 0 END) AS Bs5									 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo													 							 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findDependencias()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (b.dependencia ='S') THEN 1 ELSE 0 END) AS dSI,
										SUM(CASE WHEN (b.dependencia ='N') THEN 1 ELSE 0 END) AS dNO 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo													 					 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findViviendas()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (b.idVivienda='1') THEN 1 ELSE 0 END) AS Propia,
										SUM(CASE WHEN (b.idVivienda='2') THEN 1 ELSE 0 END) AS Anticretico,
										SUM(CASE WHEN (b.idVivienda='3') THEN 1 ELSE 0 END) AS Alquiler,
										SUM(CASE WHEN (b.idVivienda='4') THEN 1 ELSE 0 END) AS Prestada 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo
										 JOIN AppBundle:TVivienda e WITH b.idVivienda = e.idVivienda													 					 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findServira()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (a.idServira='1') THEN 1 ELSE 0 END) AS Emprender,
										SUM(CASE WHEN (a.idServira='2') THEN 1 ELSE 0 END) AS Buscar,
										SUM(CASE WHEN (a.idServira='3') THEN 1 ELSE 0 END) AS Familia,
										SUM(CASE WHEN (a.idServira='4') THEN 1 ELSE 0 END) AS Ensenar,
										SUM(CASE WHEN (a.idServira='5') THEN 1 ELSE 0 END) AS Aprender,
										SUM(CASE WHEN (a.idServira='7') THEN 1 ELSE 0 END) AS Trabajar,
										SUM(CASE WHEN (a.idServira='8') THEN 1 ELSE 0 END) AS Mejorar,
										SUM(CASE WHEN (a.idServira='6') THEN 1 ELSE 0 END) AS Otro 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo										 
										 JOIN AppBundle:TServira e WITH a.idServira = e.idServira													 					 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findViolencias()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (b.violencia ='S') THEN 1 ELSE 0 END) AS vSI,
										SUM(CASE WHEN (b.violencia ='N') THEN 1 ELSE 0 END) AS vNO 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo													 					 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findVictimas()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (b.victima ='S') THEN 1 ELSE 0 END) AS vSI,
										SUM(CASE WHEN (b.victima ='N') THEN 1 ELSE 0 END) AS vNO 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo													 					 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findAtenciones()
	{
		return $this->getEntityManager()
		            ->createQuery("SELECT concat(c.gestion, '-', c.semestre) as periodo, 
										SUM(CASE WHEN (b.idTipoviolencia ='1') THEN 1 ELSE 0 END) AS Fisica,
										SUM(CASE WHEN (b.idTipoviolencia ='2') THEN 1 ELSE 0 END) AS Psicologica,
										SUM(CASE WHEN (b.idTipoviolencia ='3') THEN 1 ELSE 0 END) AS Sexual,
										SUM(CASE WHEN (b.idTipoviolencia ='4') THEN 1 ELSE 0 END) AS Economica,
										SUM(CASE WHEN (b.idTipoviolencia ='5') THEN 1 ELSE 0 END) AS Laboral,
										SUM(CASE WHEN (b.idTipoviolencia ='6') THEN 1 ELSE 0 END) AS Patrimonial,
										SUM(CASE WHEN (b.idTipoviolencia ='7') THEN 1 ELSE 0 END) AS Simbolica 										 
										FROM AppBundle:TInscripcion a
										 JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
										 join AppBundle:TCurso d WITH a.idCurso = d.idCurso
										 join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo										 
										 JOIN AppBundle:TTipoviolencia e WITH b.idTipoviolencia = e.idTipoviolencia													 					 
										GROUP BY c.gestion, c.semestre ORDER BY c.gestion, c.semestre"
		            )->getResult();
	}

	public function findGeneral()
	{

		$conexion = mysqli_connect( 'localhost', 'juanquimon', "123456" ) or die ("No se ha podido conectar al servidor de Base de datos");
//		$conexion = mysqli_connect( 'localhost', 'naycar5_aladmin', "7*Almalogist" ) or die ("No se ha podido conectar al servidor de Base de datos");
//		Sirve para que salga las ñ acentos, etc.
		mysqli_query($conexion, "SET NAMES 'utf8'");
//		mysqli_set_charset($conexion,'utf8');
		$db = mysqli_select_db( $conexion, 'bd_mumi') or die ( "Upps! No se ha podido conectar a la base de datos" );
//		$db = mysqli_select_db( $conexion, 'naycar5_mumi') or die ( "Upps! No se ha podido conectar a la base de datos" );


		$consulta = "SELECT p.gestion, p.semestre, b.carnet, b.paterno, b.materno, b.nombre, b.genero, b.nacimiento, 
					j.desc_Provincia as prov_nacimiento, k.desc_Tiempo, l.desc_Provincia as prov_padres, b.zona, b.direccion,
					h.desc_distrito, b.telefono, g.desc_Civil, i.desc_Grado as NivelInstruccion, b.correo, q.desc_carrera, d.paralelo, o.desc_turno,
					a.asistencia, a.transversal, a.nota, t.desc_estado,
					r.desc_servira, e.desc_informo, b.trabajo, b.dependencia, m.desc_Dependencia,
					b.monto_Apoyo, b.ingreso, f.desc_Categoria, b.violencia as conoceViolencia, b.victima as fueVictima, s.desc_tipoviolencia,
					b.hijos, c.desc_Economico as ocupacion, n.desc_Vivienda, a.id_inscripcion								
					FROM t_inscripcion a 
					INNER  JOIN t_estudiante b ON a.id_Estudiante = b.id_Estudiante
					INNER  JOIN t_economico c ON b.id_Economico = c.id_Economico
					INNER  JOIN t_curso d ON d.id_Curso = a.id_Curso
					INNER  JOIN t_carrera q on q.id_carrera = d.id_carrera
					INNER  JOIN t_turno o ON o.id_Turno = d.id_Turno
					INNER  JOIN t_informo e ON a.id_Informo = e.id_Informo
					INNER  JOIN t_categoria f ON f.id_Categoria = b.id_Categoria
					INNER  JOIN t_civil g ON g.id_Civil = b.id_Civil
					INNER  JOIN t_distrito h ON h.id_Distrito = b.id_Distrito
					INNER  JOIN t_grado i ON i.id_Grado = b.id_Grado
					INNER  JOIN t_provincia j ON j.id_Provincia = b.id_Provincia
					INNER  JOIN t_periodo p ON p.id_Periodo = d.id_Periodo
					INNER  JOIN t_vivienda n ON n.id_Vivienda = b.id_Vivienda										
					INNER  JOIN t_provincia l ON l.id_Provincia = b.id_Provincia2
					INNER  JOIN t_servira r ON r.id_servira = a.id_servira																								 
					INNER  JOIN t_estado t ON t.id_estado = a.id_estado
					LEFT JOIN t_tipoviolencia s ON s.id_tipoviolencia = b.id_tipoviolencia
					LEFT JOIN t_tiempo k ON k.id_Tiempo = b.id_Tiempo 
					LEFT JOIN t_dependencia m ON m.id_Dependencia = b.id_Dependencia 
					ORDER BY p.gestion, p.semestre, q.desc_carrera, d.paralelo, o.desc_turno, b.paterno, b.materno, b.nombre";

		$resultado = mysqli_query( $conexion, $consulta )  or die ( "Algo ha ido mal en la consulta a la base de datos");

		return $resultado;
	}




	/***************************ADVENTISTA******************************/
    public function findCursosProfeEvaluar($periodoActivo, $usuario)
    {
        if($usuario->getIdRol()->getIdRol() == 1)
            $idUsuario = '';
        else
            $idUsuario = 'AND a.idUsuario = ' . $usuario->getIdUsuario();

        return $this->getEntityManager()
            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso, 
            d.idEvaluacion, d.titulo, COALESCE(d.numeroPreguntas, 0) AS numeroPreguntas, d.fechaCreacion, d.fechaInicio, d.fechaFin, d.minutos, d.activo, COUNT(e.pregunta) AS preguntas 
                    from AppBundle:TCurso a 
                     join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
                     join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera	
                     left join AppBundle:TEvaluacion d WITH d.idCurso = a.idCurso									 
                     left join AppBundle:TPregunta e WITH e.idEvaluacion = d.idEvaluacion									 
                    where b.activo = " . $periodoActivo . " " . $idUsuario . "
                    GROUP BY  a.idCurso, b.gestion, b.semestre, c.descCarrera, 
                    d.idEvaluacion, d.titulo, d.numeroPreguntas, d.fechaCreacion, d.fechaInicio, d.fechaFin, d.minutos, d.activo
                    order by b.gestion, b.semestre, c.descCarrera "
            )->getResult();
    }

    public function findCantPreguntas($idEvaluacion)
    {
        return $this->getEntityManager()
            ->createQuery("select count(a.idPregunta) as cant 
                    from AppBundle:TPregunta a 
                    where a.idEvaluacion = " . $idEvaluacion
            )->getResult();
    }

    public function findBorraUsuario($userName)
    {
        return $this->getEntityManager()
            ->createQuery("delete 
                    from AppBundle:TUsuario a 
                    where a.username = " . $userName
            )->getResult();
    }

    public function findCursosEstudiante($periodoActivo, $usuario)
    {
        if($usuario->getIdRol()->getIdRol() == 1 OR $usuario->getIdRol()->getIdRol() == 2 OR $usuario->getIdRol()->getIdRol() == 4)
            return $this->getEntityManager()
 		            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera										 
										where b.activo = " . $periodoActivo . " 
										order by b.gestion, b.semestre, c.descCarrera "
                    )->getResult();

        if($usuario->getIdRol()->getIdRol() == 3)
            return $this->getEntityManager()
                ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera										 
										where b.activo = " . $periodoActivo . " AND a.idUsuario = " . $usuario->getIdUsuario() . "
                                        order by b.gestion, b.semestre, c.descCarrera "
                )->getResult();

        if($usuario->getIdRol()->getIdRol() == 5)
            return $this->getEntityManager()
                ->createQuery("select DISTINCT d.idCurso, CONCAT(c.gestion,' ', c.semestre, ' ', e.descCarrera) AS curso                                         
                                        FROM AppBundle:TInscripcion a
                                         JOIN AppBundle:TEstudiante b WITH a.idEstudiante = b.idEstudiante 
                                         join AppBundle:TCurso d WITH a.idCurso = d.idCurso
                                         join AppBundle:TPeriodo c WITH d.idPeriodo = c.idPeriodo	
                                         join AppBundle:TCarrera e WITH e.idCarrera = d.idCarrera
                                         where c.activo = " . $periodoActivo . " AND b.carnet = " . $usuario->getUsCarnet() . " 
                                         order by c.gestion, c.semestre, e.descCarrera"
                )->getResult();

    }


    public function findContenidoEspecíficoProfe($periodoActivo, $idCurso, $usuario, $idTipo)
    {
        if($usuario->getIdRol()->getIdRol() == 3)
            $idUsuario = ' AND a.idUsuario = ' . $usuario->getIdUsuario();
        else
            $idUsuario = '';

        return $this->getEntityManager()
            ->createQuery("select a.idCurso, e.nombre as tipoMaterial, d.fecha, d.idContenido, d.descripcion, 
                                f.usnombres as responsable, d.titulo, d.fuente, d.archivo1, d.archivo2, d.archivo3, d.activo
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera
										 join AppBundle:TContenido d WITH d.idCarrera = c.idCarrera 										 
										 join AppBundle:TTipomaterial e WITH e.idTipoMaterial = d.idTipoMaterial
										 join AppBundle:TUsuario f WITH f.idUsuario = d.idUsuario
										where b.activo = " . $periodoActivo . " AND d.idTipoMaterial = ". $idTipo . " AND a.idCurso = " . $idCurso . $idUsuario . "
										order by b.gestion, b.semestre, c.descCarrera "
            )->getResult();
    }


    public function findCursoEspecífico($periodoActivo, $idCurso)
    {

            return $this->getEntityManager()
                ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso, d.fechaInicio, d.fechaFin, d.minutos, CURRENT_TIMESTAMP() as Hoy, c.idCarrera 
										from AppBundle:TCurso a 
										 join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
										 join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera
										 left join AppBundle:TEvaluacion d WITH d.idCurso = a.idCurso and d.activo = 1										 
										where b.activo = " . $periodoActivo . " AND a.idCurso = " . $idCurso . "
										order by b.gestion, b.semestre, c.descCarrera "
                )->getResult();
    }

    public function findEstudiantePreguntas($idCurso, $usuario)
    {
//        var_dump($usuario->getUsCarnet()); exit();
        return $this->getEntityManager()
            ->createQuery("select a.idCurso, d.fechaInicio, d.fechaFin, d.minutos, CURRENT_TIMESTAMP() as Hoy,
                e.idPregunta, e.numeroPregunta, e.pregunta, e.alternativa1, e.alternativa2, e.alternativa3, e.puntaje, e.respuestaCorrecta, d.idEvaluacion, 
                CONCAT(COALESCE(j.paterno,''), ' ', COALESCE(j.materno,''), ' ', j.nombre) as nombre, j.carnet, i.idInscripcion                  
                        FROM AppBundle:TInscripcion i
                        JOIN AppBundle:TEstudiante j WITH i.idEstudiante = j.idEstudiante 
                        join AppBundle:TCurso a WITH i.idCurso = a.idCurso
                         join AppBundle:TEvaluacion d WITH d.idCurso = a.idCurso and d.activo = 1
                         join AppBundle:TPregunta e WITH d.idEvaluacion = e.idEvaluacion										 
                        where e.activo = 1 AND a.idCurso = " . $idCurso . " AND j.carnet = " . $usuario->getUsCarnet()
            )->getResult();
    }

    public function findExamen($idEvaluacion, $usCarnet)
    {
        return $this->getEntityManager()
            ->createQuery("SELECT (f.idInscripcion) as idInscripcion, (f.idEvaluacion) as idEvaluacion, sum(f.puntajeObtenido) AS puntajeObtenido                  
                        FROM AppBundle:TInscripcion i
                        JOIN AppBundle:TEstudiante j WITH i.idEstudiante = j.idEstudiante 										 
                        join AppBundle:TRespuesta f WITH f.idInscripcion = i.idInscripcion										 
                        where f.idEvaluacion = " . $idEvaluacion . " AND j.carnet = " . $usCarnet ."
                        Group by f.idInscripcion, f.idEvaluacion "
            )->getResult();
    }

    public function findRespuestas($idCurso, $usuario, $periodoActivo)
    {
        return $this->getEntityManager()
            ->createQuery("select a.idCurso, CONCAT(b.gestion,' ', b.semestre, ' ', c.descCarrera) AS curso, d.fechaInicio, d.fechaFin, d.minutos, CURRENT_TIMESTAMP() as Hoy,
                e.idPregunta, e.numeroPregunta, e.pregunta, e.alternativa1, e.alternativa2, e.alternativa3, e.puntaje, e.respuestaCorrecta, d.idEvaluacion, 
                CONCAT(COALESCE(j.paterno,''), ' ', COALESCE(j.materno,''), ' ', j.nombre) as nombre, j.carnet, i.idInscripcion, f.idRespuesta, f.respuesta                  
                        FROM AppBundle:TInscripcion i
                        JOIN AppBundle:TEstudiante j WITH i.idEstudiante = j.idEstudiante 
                        join AppBundle:TCurso a WITH i.idCurso = a.idCurso
                         join AppBundle:TPeriodo b WITH a.idPeriodo = b.idPeriodo
                         join AppBundle:TCarrera c WITH a.idCarrera = c.idCarrera
                         join AppBundle:TEvaluacion d WITH d.idCurso = a.idCurso and d.activo = 1
                         join AppBundle:TPregunta e WITH d.idEvaluacion = e.idEvaluacion										 
                         join AppBundle:TRespuesta f WITH f.idPregunta = e.idPregunta AND f.idInscripcion = i.idInscripcion									 
                        where e.activo = 1 and b.activo = " . $periodoActivo . " AND a.idCurso = " . $idCurso . " AND j.carnet = " . $usuario->getUsCarnet()
            )->getResult();
    }

    public function actualizaRespuesta($idR, $resp, $ptj)
    {
        return $this->getEntityManager()
            ->createQuery(
                "UPDATE AppBundle:TRespuesta a SET a.respuesta = " . "'".$resp."'" . ", a.puntajeObtenido = ". $ptj ."
			                    WHERE a.idRespuesta = " . $idR
            )->getResult();
    }

    public function actualizaNota($idInscripcion)
    {

        $conexion = mysqli_connect( 'localhost', 'juanquimon', "123456" ) or die ("No se ha podido conectar al servidor de Base de datos");
//		$conexion = mysqli_connect( 'localhost', 'naycar5_PeopleUser', "7People7" ) or die ("No se ha podido conectar al servidor de Base de datos");
//		Sirve para que salga las ñ acentos, etc.
        mysqli_query($conexion, "SET NAMES 'utf8'");
//		mysqli_set_charset($conexion,'utf8');
        $db = mysqli_select_db( $conexion, 'bd_adventista') or die ( "Upps! No se ha podido conectar a la base de datos" );
//		$db = mysqli_select_db( $conexion, 'naycar5_adventista') or die ( "Upps! No se ha podido conectar a la base de datos" );


        $consulta = "UPDATE t_inscripcion a
                        join
                        (select sum(puntaje_obtenido) as nota, id_inscripcion from t_respuesta where id_inscripcion = $idInscripcion) b 
                        on a.id_inscripcion = b.id_inscripcion 
                        SET a.nota = b.nota
                        where a.id_inscripcion = $idInscripcion";

        $resultado = mysqli_query( $conexion, $consulta )  or die ( "Algo ha ido mal en la consulta a la base de datos");

        return $resultado;
    }

    public function findPreguntasRespuestas($idCurso)
    {
        return $this->getEntityManager()
            ->createQuery("select (a.idCurso) as idCurso, a.numeroPreguntas, COUNT(b.pregunta) AS preguntas 
										from AppBundle:TEvaluacion a 
										join AppBundle:TPregunta b WITH a.idEvaluacion = b.idEvaluacion																				 
										where a.idCurso = " . $idCurso . "
										GROUP BY a.idCurso, a.numeroPreguntas"
            )->getResult();
    }

    public function findDobleInscripcion($idCurso, $carnet)
    {
        return $this->getEntityManager()
            ->createQuery("select a.idInscripcion 
										from AppBundle:TInscripcion a 
										 join AppBundle:TEstudiante f WITH a.idEstudiante = f.idEstudiante
										 WHERE f.carnet = ". $carnet . " AND a.idCurso = " . $idCurso
            )->getResult();
    }
}